using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Microsoft.Win32;

namespace CbModel
{
	/// <summary>
	/// Summary description for IntroForm.
	/// </summary>
	public class PromptForLoginForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label emailLbl;
		private System.Windows.Forms.TextBox emailText;
		private System.Windows.Forms.Label nameLbl;
		private System.Windows.Forms.GroupBox personalBox;
		private System.Windows.Forms.Label serverNameLbl;
		private System.Windows.Forms.Label machineLbl;
		private System.Windows.Forms.GroupBox serverBox;
		private System.Windows.Forms.TextBox nameText;
		private System.Windows.Forms.TextBox locationText;
		private System.Windows.Forms.TextBox serverNameText;
		private System.Windows.Forms.Button okBtn;
		private System.Windows.Forms.Button cancelBtn;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		private bool ok;
		private RegistryKey rkey;
		private const string registryRoot = "Software\\VB and VBA Program Settings\\GlabCommunityBar\\UserProperties";

		public PromptForLoginForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			this.ok = false;

			// access the registry keys
			this.rkey = Registry.CurrentUser;
			this.rkey = this.rkey.CreateSubKey(registryRoot);
			string val = (string)this.rkey.GetValue("email");
			if (val == null)
			{
				this.emailText.Text = "guest@anonymous.com";
			}
			else
			{
				this.emailText.Text = val;
			}
			val = (string)this.rkey.GetValue("displayName");
			if (val == null)
			{
				this.nameText.Text = "anonymous";
			}
			else
			{
				this.nameText.Text = val;
			}
			val = (string)this.rkey.GetValue("serverLocation");
			if (val == null)
			{
				this.locationText.Text = "ilab.cpsc.ucalgary.ca";
			}
			else
			{
				this.locationText.Text = val;
			}
			val = (string)this.rkey.GetValue("serverName");
			if (val == null)
			{
				this.serverNameText.Text = "23";
			}
			else
			{
				this.serverNameText.Text = val;
			}

			this.Text = "Community Bar 3.1.2";
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.emailLbl = new System.Windows.Forms.Label();
			this.emailText = new System.Windows.Forms.TextBox();
			this.nameLbl = new System.Windows.Forms.Label();
			this.serverNameLbl = new System.Windows.Forms.Label();
			this.personalBox = new System.Windows.Forms.GroupBox();
			this.nameText = new System.Windows.Forms.TextBox();
			this.machineLbl = new System.Windows.Forms.Label();
			this.serverBox = new System.Windows.Forms.GroupBox();
			this.serverNameText = new System.Windows.Forms.TextBox();
			this.locationText = new System.Windows.Forms.TextBox();
			this.okBtn = new System.Windows.Forms.Button();
			this.cancelBtn = new System.Windows.Forms.Button();
			this.personalBox.SuspendLayout();
			this.serverBox.SuspendLayout();
			this.SuspendLayout();
			// 
			// emailLbl
			// 
			this.emailLbl.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.emailLbl.Location = new System.Drawing.Point(8, 24);
			this.emailLbl.Name = "emailLbl";
			this.emailLbl.Size = new System.Drawing.Size(112, 24);
			this.emailLbl.TabIndex = 0;
			this.emailLbl.Text = "Email address";
			this.emailLbl.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// emailText
			// 
			this.emailText.Location = new System.Drawing.Point(120, 24);
			this.emailText.Name = "emailText";
			this.emailText.Size = new System.Drawing.Size(160, 20);
			this.emailText.TabIndex = 1;
			this.emailText.Text = "mcewan@cpsc.ucalgary.ca";
			// 
			// nameLbl
			// 
			this.nameLbl.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.nameLbl.Location = new System.Drawing.Point(8, 64);
			this.nameLbl.Name = "nameLbl";
			this.nameLbl.Size = new System.Drawing.Size(104, 24);
			this.nameLbl.TabIndex = 2;
			this.nameLbl.Text = "Display Name";
			this.nameLbl.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// serverNameLbl
			// 
			this.serverNameLbl.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.serverNameLbl.Location = new System.Drawing.Point(8, 64);
			this.serverNameLbl.Name = "serverNameLbl";
			this.serverNameLbl.Size = new System.Drawing.Size(104, 24);
			this.serverNameLbl.TabIndex = 3;
			this.serverNameLbl.Text = "Server Name";
			this.serverNameLbl.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// personalBox
			// 
			this.personalBox.Controls.Add(this.nameText);
			this.personalBox.Controls.Add(this.emailLbl);
			this.personalBox.Controls.Add(this.emailText);
			this.personalBox.Controls.Add(this.nameLbl);
			this.personalBox.Location = new System.Drawing.Point(0, 8);
			this.personalBox.Name = "personalBox";
			this.personalBox.Size = new System.Drawing.Size(288, 104);
			this.personalBox.TabIndex = 4;
			this.personalBox.TabStop = false;
			this.personalBox.Text = "Personal Details";
			// 
			// nameText
			// 
			this.nameText.Location = new System.Drawing.Point(120, 64);
			this.nameText.Name = "nameText";
			this.nameText.Size = new System.Drawing.Size(160, 20);
			this.nameText.TabIndex = 3;
			this.nameText.Text = "g";
			// 
			// machineLbl
			// 
			this.machineLbl.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.machineLbl.Location = new System.Drawing.Point(8, 24);
			this.machineLbl.Name = "machineLbl";
			this.machineLbl.Size = new System.Drawing.Size(104, 24);
			this.machineLbl.TabIndex = 5;
			this.machineLbl.Text = "Server Location";
			this.machineLbl.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// serverBox
			// 
			this.serverBox.Controls.Add(this.serverNameText);
			this.serverBox.Controls.Add(this.locationText);
			this.serverBox.Controls.Add(this.serverNameLbl);
			this.serverBox.Controls.Add(this.machineLbl);
			this.serverBox.Location = new System.Drawing.Point(0, 120);
			this.serverBox.Name = "serverBox";
			this.serverBox.Size = new System.Drawing.Size(288, 104);
			this.serverBox.TabIndex = 6;
			this.serverBox.TabStop = false;
			this.serverBox.Text = "Server Details";
			// 
			// serverNameText
			// 
			this.serverNameText.Location = new System.Drawing.Point(120, 64);
			this.serverNameText.Name = "serverNameText";
			this.serverNameText.Size = new System.Drawing.Size(160, 20);
			this.serverNameText.TabIndex = 7;
			this.serverNameText.Text = "23";
			// 
			// locationText
			// 
			this.locationText.Location = new System.Drawing.Point(120, 24);
			this.locationText.Name = "locationText";
			this.locationText.Size = new System.Drawing.Size(160, 20);
			this.locationText.TabIndex = 6;
			this.locationText.Text = "localhost";
			// 
			// okBtn
			// 
			this.okBtn.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.okBtn.Location = new System.Drawing.Point(120, 240);
			this.okBtn.Name = "okBtn";
			this.okBtn.TabIndex = 7;
			this.okBtn.Text = "OK";
			this.okBtn.Click += new System.EventHandler(this.okBtn_Click);
			// 
			// cancelBtn
			// 
			this.cancelBtn.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.cancelBtn.Location = new System.Drawing.Point(208, 240);
			this.cancelBtn.Name = "cancelBtn";
			this.cancelBtn.TabIndex = 8;
			this.cancelBtn.Text = "Cancel";
			this.cancelBtn.Click += new System.EventHandler(this.cancelBtn_Click);
			// 
			// IntroForm
			// 
			this.AcceptButton = this.okBtn;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.cancelBtn;
			this.ClientSize = new System.Drawing.Size(292, 277);
			this.Controls.Add(this.cancelBtn);
			this.Controls.Add(this.okBtn);
			this.Controls.Add(this.serverBox);
			this.Controls.Add(this.personalBox);
			this.Name = "IntroForm";
			this.Text = "IntroForm";
			this.personalBox.ResumeLayout(false);
			this.serverBox.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void okBtn_Click(object sender, System.EventArgs e)
		{
			this.ok = true;

			// write the values to the registry
			this.rkey.SetValue("email", this.emailText.Text);
			this.rkey.SetValue("displayName", this.nameText.Text);
			this.rkey.SetValue("serverLocation", this.locationText.Text);
			this.rkey.SetValue("serverName", this.serverNameText.Text);
		}

		private void cancelBtn_Click(object sender, System.EventArgs e)
		{
			this.Visible = false;
		}

		public bool OK
		{
			get
			{
				return this.ok;
			}
		}

		public string Email
		{
			get
			{
				return this.emailText.Text;
			}
		}

		public string ServerName
		{
			get
			{
				return "tcp://"+this.locationText.Text+":"+this.serverNameText.Text;
			}
		}

		public string DisplayName
		{
			get
			{
				return this.nameText.Text;
			}
		}
	}
}
