using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using CbModel;

namespace TestBench
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.MainMenu mainMenu1;
		private CbModel.MainModel mainModel1;
		private System.Windows.Forms.MenuItem windowsMenuItem;
		private System.Windows.Forms.MenuItem placesMenuItem;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.ComponentModel.IContainer components;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.placesMenuItem = new System.Windows.Forms.MenuItem();
			this.windowsMenuItem = new System.Windows.Forms.MenuItem();
			this.mainModel1 = new CbModel.MainModel(this.components);
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.placesMenuItem,
																					  this.windowsMenuItem});
			// 
			// placesMenuItem
			// 
			this.placesMenuItem.Enabled = false;
			this.placesMenuItem.Index = 0;
			this.placesMenuItem.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						   this.menuItem1});
			this.placesMenuItem.Text = "Places";
			// 
			// windowsMenuItem
			// 
			this.windowsMenuItem.Index = 1;
			this.windowsMenuItem.MdiList = true;
			this.windowsMenuItem.Text = "Windows";
			// 
			// mainModel1
			// 
			this.mainModel1.PlaceAdded += new CbModel.PlaceEventHandler(this.mainModel1_PlaceAdded);
			this.mainModel1.PlaceRemoved += new CbModel.PlaceEventHandler(this.mainModel1_PlaceRemoved);
			this.mainModel1.Stopped += new System.EventHandler(this.mainModel1_Stopped);
			this.mainModel1.Started += new System.EventHandler(this.mainModel1_Started);
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.Text = "New Place";
			this.menuItem1.Click += new System.EventHandler(this.menuItem1_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 273);
			this.IsMdiContainer = true;
			this.Menu = this.mainMenu1;
			this.Name = "Form1";
			this.Text = "My Community";
			this.Load += new System.EventHandler(this.Form1_Load);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		Hashtable menuItemsToItemTypes = new Hashtable();
		Hashtable menuItemsToPlaces = new Hashtable();
		Hashtable placesToMenuItems = new Hashtable();

		private void Form1_Load(object sender, System.EventArgs e)
		{
//			foreach(string t in mainModel1.ItemTypes)
//			{
//				MenuItem i = new MenuItem(t);
//				menuItemsToItemTypes.Add(i, t);
//				i.Click += new EventHandler(itemAddMenuItem_Click);
//				itemsMenuItem.MenuItems.Add(i);
//			}
			if(DialogResult.OK != mainModel1.PromptForLogin())
			{
				Application.Exit();
			}
			else
			{
				mainModel1.Start();
			}
		}

		private void mainModel1_Started(object sender, System.EventArgs e)
		{
			//itemsMenuItem.Enabled = true;
			placesMenuItem.Enabled = true;
			menuItemsToPlaces.Clear();
			//itemsMenuItem.MenuItems.Clear();
			placesToMenuItems.Clear();
			//placesMenuItem.MenuItems.Clear();

			// subscribe to owner events
			this.mainModel1.Owner.SubscribedPlace += new PlaceEventHandler(Owner_SubscribedPlace);
		}

		private void mainModel1_PlaceRemoved(object sender, CbModel.PlaceEventArgs e)
		{
			MenuItem i = placesToMenuItems[e.Place] as MenuItem;
			placesMenuItem.MenuItems.Remove(i);
		}

		private void mainModel1_PlaceAdded(object sender, CbModel.PlaceEventArgs e)
		{
			MenuItem i = new MenuItem(e.Place.Name);
			i.Click += new EventHandler(placeMenuItem_Click);
			placesMenuItem.MenuItems.Add(i);
			menuItemsToPlaces[i] = e.Place;
			placesToMenuItems[e.Place] = i;
		}

		private void mainModel1_ItemRemoved(object sender, CbModel.ItemEventArgs e)
		{
			(e.Item.Tag as Form).Close();
		}

		private void mainModel1_ItemAdded(object sender, CbModel.ItemEventArgs e)
		{
			Form f = new Form();
			e.Item.Tag = f;
			f.Tag = e.Item;
			f.Text = e.Item.Owner.DisplayName;
			f.Closing += new CancelEventHandler(itemForm_Closing);
			f.MdiParent = e.Item.Place.Tag as Form;
			f.Size = new Size(320, 240);
			Control c = e.Item.GetTransientFocus(new Size(320, 240));
			c.Dock = DockStyle.Fill;
			f.Controls.Add(c);
			f.Show();
		}

		private void mainModel1_Stopped(object sender, System.EventArgs e)
		{
			placesMenuItem.Enabled = false;
		}

		private void itemAddMenuItem_Click(object sender, EventArgs e)
		{
			//mainModel1.CreateItem(menuItemsToItemTypes[sender] as ItemType);
		}

		private void placeForm_Closing(object sender, CancelEventArgs e)
		{
			DialogResult d = MessageBox.Show(this, "Do you want to unsubscribe from this place?", "My Community", MessageBoxButtons.YesNoCancel);
			if(d == DialogResult.Cancel)
			{
				e.Cancel = true;
			}
			else if(d == DialogResult.Yes)
			{
				((sender as Form).Tag as Place).Unsubscribe(this.mainModel1.Owner);
			}
		}

		private void itemForm_Closing(object sender, CancelEventArgs e)
		{
			if(((sender as Form).Tag as Item).Owner == mainModel1.Owner)
			{
				((sender as Form).Tag as Item).Delete();
			}
		}

		private void placeMenuItem_Click(object sender, EventArgs e)
		{
			MenuItem i = sender as MenuItem;
			Place p = menuItemsToPlaces[i] as Place;
			if(p.IsSubscribed(this.mainModel1.Owner))
			{
				p.Unsubscribe(this.mainModel1.Owner);
			}
			else
			{
				this.mainModel1.Owner.SubscribePlace(p);
			}
		}

		private void menuItem1_Click(object sender, System.EventArgs e)
		{
			// make a new place
			this.mainModel1.CreatePlace("a place");
		}

		private void Owner_SubscribedPlace(object sender, PlaceEventArgs e)
		{
			MenuItem i = placesToMenuItems[e.Place] as MenuItem;
			i.Checked = true;
			Form f = new Form();
			f.Closing += new CancelEventHandler(placeForm_Closing);
			f.Tag = e.Place;
			e.Place.Tag = f;
			f.Text = e.Place.Name;
			f.IsMdiContainer = true;
			f.MdiParent = this;
			f.Size = new Size(800, 600);

			// add the items menu
			System.Windows.Forms.MainMenu itemsMenu = new MainMenu();
			MenuItem itemsMenuItem = new MenuItem();
			itemsMenuItem.Enabled = true;
			itemsMenuItem.Index = 0;
			itemsMenuItem.Text = "Items";
			itemsMenu.MenuItems.Add(itemsMenuItem);

			f.Show();
		}
	}
}
