using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using CbModel;

namespace MediaItemTester
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.GroupBox masterGroupBox;
		private System.Windows.Forms.Panel masterTilePanel;
		private System.Windows.Forms.TrackBar masterTrackBar;
		private System.Windows.Forms.Panel masterTransientPanel;
		private System.Windows.Forms.Button masterShowSeparateBtn;

		private CbModel.MainModel masterModel;
		private CbModel.MainModel slave1Model;
		private CbModel.MainModel slave2Model;

		private string itemType;
		private string itemKey;

		private CbModel.Place masterTestPlace;
		private CbModel.Place slave1TestPlace;
		private CbModel.Place slave2TestPlace;

		private CbModel.Item masterItem;
		private System.Windows.Forms.MenuItem loadItemMenu;
		private System.Windows.Forms.MainMenu itemMenu;
		private CbModel.Item slave1Item;
		private CbModel.Item slave2Item;

		private bool masterPlaceSubscribed;
		private System.Windows.Forms.Button masterShowTransientBtn;
		private bool slave1PlaceSubscribed;
		private bool slave2PlaceSubscribed;

		private bool masterTransientVisible;
		private System.Windows.Forms.GroupBox slave1GroupBox;
		private System.Windows.Forms.Button slave1ShowSeparateBtn;
		private System.Windows.Forms.Panel slave1TransientPanel;
		private System.Windows.Forms.TrackBar slave1TrackBar;
		private System.Windows.Forms.Button slave1ShowTransientBtn;
		private System.Windows.Forms.Panel slave1TilePanel;
		private System.Windows.Forms.GroupBox slave2GroupBox;
		private System.Windows.Forms.Button slave1ConnectBtn;
		private System.Windows.Forms.Button slave2ConnectBtn;
		private bool slave1TransientVisible;
		private System.Windows.Forms.Button slave2ShowSeparateBtn;
		private System.Windows.Forms.Panel slave2TransientPanel;
		private System.Windows.Forms.TrackBar slave2TrackBar;
		private System.Windows.Forms.Button slave2ShowTransientBtn;
		private System.Windows.Forms.Panel slave2TilePanel;
		private System.Windows.Forms.MenuItem menuItem1;
		private bool slave2TransientVisible;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			this.Text = "Media Item Developer (Server = tcp://localhost:itemtest)";

			this.masterPlaceSubscribed = false;
			this.slave1PlaceSubscribed = false;
			this.slave2PlaceSubscribed = false;

			this.masterTransientVisible = false;
			this.slave1TransientVisible = false;
			this.slave2TransientVisible = false;

			this.masterModel = new MainModel();
			this.masterModel.SynchronizingObject = this;
			this.masterModel.Started += new EventHandler(this.masterModel_Started);
			this.masterModel.PlaceAdded += new PlaceEventHandler(this.masterModel_PlaceAdded);

			this.slave1Model = new MainModel();
			this.slave1Model.SynchronizingObject = this;
			this.slave1Model.Started += new EventHandler(this.slave1Model_Started);
			this.slave1Model.PlaceAdded += new PlaceEventHandler(this.slave1Model_PlaceAdded);
			this.slave1Model.Stopped += new EventHandler(this.slave1Model_Stopped);

			this.slave2Model = new MainModel();
			this.slave2Model.SynchronizingObject = this;
			this.slave2Model.Started += new EventHandler(this.slave2Model_Started);
			this.slave2Model.PlaceAdded += new PlaceEventHandler(this.slave2Model_PlaceAdded);
			this.slave2Model.Stopped += new EventHandler(this.slave2Model_Stopped);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.masterGroupBox = new System.Windows.Forms.GroupBox();
			this.masterShowSeparateBtn = new System.Windows.Forms.Button();
			this.masterTransientPanel = new System.Windows.Forms.Panel();
			this.masterTrackBar = new System.Windows.Forms.TrackBar();
			this.masterShowTransientBtn = new System.Windows.Forms.Button();
			this.masterTilePanel = new System.Windows.Forms.Panel();
			this.slave1GroupBox = new System.Windows.Forms.GroupBox();
			this.slave1ConnectBtn = new System.Windows.Forms.Button();
			this.slave1ShowSeparateBtn = new System.Windows.Forms.Button();
			this.slave1TransientPanel = new System.Windows.Forms.Panel();
			this.slave1TrackBar = new System.Windows.Forms.TrackBar();
			this.slave1ShowTransientBtn = new System.Windows.Forms.Button();
			this.slave1TilePanel = new System.Windows.Forms.Panel();
			this.itemMenu = new System.Windows.Forms.MainMenu();
			this.loadItemMenu = new System.Windows.Forms.MenuItem();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.slave2GroupBox = new System.Windows.Forms.GroupBox();
			this.slave2ConnectBtn = new System.Windows.Forms.Button();
			this.slave2ShowSeparateBtn = new System.Windows.Forms.Button();
			this.slave2TransientPanel = new System.Windows.Forms.Panel();
			this.slave2TrackBar = new System.Windows.Forms.TrackBar();
			this.slave2ShowTransientBtn = new System.Windows.Forms.Button();
			this.slave2TilePanel = new System.Windows.Forms.Panel();
			this.masterGroupBox.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.masterTrackBar)).BeginInit();
			this.slave1GroupBox.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.slave1TrackBar)).BeginInit();
			this.slave2GroupBox.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.slave2TrackBar)).BeginInit();
			this.SuspendLayout();
			// 
			// masterGroupBox
			// 
			this.masterGroupBox.Controls.Add(this.masterShowSeparateBtn);
			this.masterGroupBox.Controls.Add(this.masterTransientPanel);
			this.masterGroupBox.Controls.Add(this.masterTrackBar);
			this.masterGroupBox.Controls.Add(this.masterShowTransientBtn);
			this.masterGroupBox.Controls.Add(this.masterTilePanel);
			this.masterGroupBox.Enabled = false;
			this.masterGroupBox.Location = new System.Drawing.Point(8, 8);
			this.masterGroupBox.Name = "masterGroupBox";
			this.masterGroupBox.Size = new System.Drawing.Size(304, 328);
			this.masterGroupBox.TabIndex = 0;
			this.masterGroupBox.TabStop = false;
			this.masterGroupBox.Text = "Master";
			// 
			// masterShowSeparateBtn
			// 
			this.masterShowSeparateBtn.Enabled = false;
			this.masterShowSeparateBtn.Location = new System.Drawing.Point(40, 288);
			this.masterShowSeparateBtn.Name = "masterShowSeparateBtn";
			this.masterShowSeparateBtn.Size = new System.Drawing.Size(152, 23);
			this.masterShowSeparateBtn.TabIndex = 5;
			this.masterShowSeparateBtn.Text = "Show Separate";
			this.masterShowSeparateBtn.Click += new System.EventHandler(this.masterShowSeparateBtn_Click);
			// 
			// masterTransientPanel
			// 
			this.masterTransientPanel.Location = new System.Drawing.Point(40, 128);
			this.masterTransientPanel.Name = "masterTransientPanel";
			this.masterTransientPanel.Size = new System.Drawing.Size(150, 150);
			this.masterTransientPanel.TabIndex = 4;
			// 
			// masterTrackBar
			// 
			this.masterTrackBar.Enabled = false;
			this.masterTrackBar.LargeChange = 10;
			this.masterTrackBar.Location = new System.Drawing.Point(96, 8);
			this.masterTrackBar.Maximum = 100;
			this.masterTrackBar.Minimum = 5;
			this.masterTrackBar.Name = "masterTrackBar";
			this.masterTrackBar.Size = new System.Drawing.Size(112, 42);
			this.masterTrackBar.SmallChange = 2;
			this.masterTrackBar.TabIndex = 3;
			this.masterTrackBar.TickFrequency = 5;
			this.masterTrackBar.TickStyle = System.Windows.Forms.TickStyle.TopLeft;
			this.masterTrackBar.Value = 100;
			this.masterTrackBar.Scroll += new System.EventHandler(this.masterTrackBar_Scroll);
			// 
			// masterShowTransientBtn
			// 
			this.masterShowTransientBtn.Enabled = false;
			this.masterShowTransientBtn.Location = new System.Drawing.Point(104, 64);
			this.masterShowTransientBtn.Name = "masterShowTransientBtn";
			this.masterShowTransientBtn.Size = new System.Drawing.Size(96, 23);
			this.masterShowTransientBtn.TabIndex = 1;
			this.masterShowTransientBtn.Text = "Show Transient";
			this.masterShowTransientBtn.Click += new System.EventHandler(this.masterShowTransientBtn_Click);
			// 
			// masterTilePanel
			// 
			this.masterTilePanel.Location = new System.Drawing.Point(16, 16);
			this.masterTilePanel.Name = "masterTilePanel";
			this.masterTilePanel.Size = new System.Drawing.Size(70, 100);
			this.masterTilePanel.TabIndex = 0;
			// 
			// slave1GroupBox
			// 
			this.slave1GroupBox.Controls.Add(this.slave1ConnectBtn);
			this.slave1GroupBox.Controls.Add(this.slave1ShowSeparateBtn);
			this.slave1GroupBox.Controls.Add(this.slave1TransientPanel);
			this.slave1GroupBox.Controls.Add(this.slave1TrackBar);
			this.slave1GroupBox.Controls.Add(this.slave1ShowTransientBtn);
			this.slave1GroupBox.Controls.Add(this.slave1TilePanel);
			this.slave1GroupBox.Enabled = false;
			this.slave1GroupBox.Location = new System.Drawing.Point(336, 8);
			this.slave1GroupBox.Name = "slave1GroupBox";
			this.slave1GroupBox.Size = new System.Drawing.Size(224, 320);
			this.slave1GroupBox.TabIndex = 1;
			this.slave1GroupBox.TabStop = false;
			this.slave1GroupBox.Text = "Slave-1";
			// 
			// slave1ConnectBtn
			// 
			this.slave1ConnectBtn.Enabled = false;
			this.slave1ConnectBtn.Location = new System.Drawing.Point(112, 16);
			this.slave1ConnectBtn.Name = "slave1ConnectBtn";
			this.slave1ConnectBtn.Size = new System.Drawing.Size(96, 23);
			this.slave1ConnectBtn.TabIndex = 7;
			this.slave1ConnectBtn.Text = "Connect";
			this.slave1ConnectBtn.Click += new System.EventHandler(this.slave1ConnectBtn_Click);
			// 
			// slave1ShowSeparateBtn
			// 
			this.slave1ShowSeparateBtn.Enabled = false;
			this.slave1ShowSeparateBtn.Location = new System.Drawing.Point(40, 288);
			this.slave1ShowSeparateBtn.Name = "slave1ShowSeparateBtn";
			this.slave1ShowSeparateBtn.Size = new System.Drawing.Size(152, 23);
			this.slave1ShowSeparateBtn.TabIndex = 6;
			this.slave1ShowSeparateBtn.Text = "Show Separate";
			this.slave1ShowSeparateBtn.Click += new System.EventHandler(this.slave1ShowSeparateBtn_Click);
			// 
			// slave1TransientPanel
			// 
			this.slave1TransientPanel.Location = new System.Drawing.Point(40, 128);
			this.slave1TransientPanel.Name = "slave1TransientPanel";
			this.slave1TransientPanel.Size = new System.Drawing.Size(150, 150);
			this.slave1TransientPanel.TabIndex = 5;
			// 
			// slave1TrackBar
			// 
			this.slave1TrackBar.Enabled = false;
			this.slave1TrackBar.LargeChange = 10;
			this.slave1TrackBar.Location = new System.Drawing.Point(104, 48);
			this.slave1TrackBar.Maximum = 100;
			this.slave1TrackBar.Minimum = 5;
			this.slave1TrackBar.Name = "slave1TrackBar";
			this.slave1TrackBar.Size = new System.Drawing.Size(112, 42);
			this.slave1TrackBar.SmallChange = 2;
			this.slave1TrackBar.TabIndex = 3;
			this.slave1TrackBar.TickFrequency = 5;
			this.slave1TrackBar.TickStyle = System.Windows.Forms.TickStyle.TopLeft;
			this.slave1TrackBar.Value = 100;
			this.slave1TrackBar.Scroll += new System.EventHandler(this.slave1TrackBar_Scroll);
			// 
			// slave1ShowTransientBtn
			// 
			this.slave1ShowTransientBtn.Enabled = false;
			this.slave1ShowTransientBtn.Location = new System.Drawing.Point(112, 96);
			this.slave1ShowTransientBtn.Name = "slave1ShowTransientBtn";
			this.slave1ShowTransientBtn.Size = new System.Drawing.Size(96, 23);
			this.slave1ShowTransientBtn.TabIndex = 1;
			this.slave1ShowTransientBtn.Text = "Show Transient";
			this.slave1ShowTransientBtn.Click += new System.EventHandler(this.slave1ShowTransientBtn_Click);
			// 
			// slave1TilePanel
			// 
			this.slave1TilePanel.Location = new System.Drawing.Point(16, 16);
			this.slave1TilePanel.Name = "slave1TilePanel";
			this.slave1TilePanel.Size = new System.Drawing.Size(70, 100);
			this.slave1TilePanel.TabIndex = 0;
			// 
			// itemMenu
			// 
			this.itemMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.loadItemMenu});
			// 
			// loadItemMenu
			// 
			this.loadItemMenu.Enabled = false;
			this.loadItemMenu.Index = 0;
			this.loadItemMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						 this.menuItem1});
			this.loadItemMenu.Text = "Load Item";
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.Text = "Presence";
			this.menuItem1.Click += new System.EventHandler(this.itemMenu_Click);
			// 
			// slave2GroupBox
			// 
			this.slave2GroupBox.Controls.Add(this.slave2ConnectBtn);
			this.slave2GroupBox.Controls.Add(this.slave2ShowSeparateBtn);
			this.slave2GroupBox.Controls.Add(this.slave2TransientPanel);
			this.slave2GroupBox.Controls.Add(this.slave2TrackBar);
			this.slave2GroupBox.Controls.Add(this.slave2ShowTransientBtn);
			this.slave2GroupBox.Controls.Add(this.slave2TilePanel);
			this.slave2GroupBox.Enabled = false;
			this.slave2GroupBox.Location = new System.Drawing.Point(568, 8);
			this.slave2GroupBox.Name = "slave2GroupBox";
			this.slave2GroupBox.Size = new System.Drawing.Size(224, 320);
			this.slave2GroupBox.TabIndex = 2;
			this.slave2GroupBox.TabStop = false;
			this.slave2GroupBox.Text = "Slave-2";
			// 
			// slave2ConnectBtn
			// 
			this.slave2ConnectBtn.Enabled = false;
			this.slave2ConnectBtn.Location = new System.Drawing.Point(112, 16);
			this.slave2ConnectBtn.Name = "slave2ConnectBtn";
			this.slave2ConnectBtn.Size = new System.Drawing.Size(96, 23);
			this.slave2ConnectBtn.TabIndex = 8;
			this.slave2ConnectBtn.Text = "Connect";
			this.slave2ConnectBtn.Click += new System.EventHandler(this.slave2ConnectBtn_Click);
			// 
			// slave2ShowSeparateBtn
			// 
			this.slave2ShowSeparateBtn.Enabled = false;
			this.slave2ShowSeparateBtn.Location = new System.Drawing.Point(40, 288);
			this.slave2ShowSeparateBtn.Name = "slave2ShowSeparateBtn";
			this.slave2ShowSeparateBtn.Size = new System.Drawing.Size(152, 23);
			this.slave2ShowSeparateBtn.TabIndex = 6;
			this.slave2ShowSeparateBtn.Text = "Show Separate";
			this.slave2ShowSeparateBtn.Click += new System.EventHandler(this.slave2ShowSeparateBtn_Click);
			// 
			// slave2TransientPanel
			// 
			this.slave2TransientPanel.Location = new System.Drawing.Point(40, 128);
			this.slave2TransientPanel.Name = "slave2TransientPanel";
			this.slave2TransientPanel.Size = new System.Drawing.Size(150, 150);
			this.slave2TransientPanel.TabIndex = 5;
			// 
			// slave2TrackBar
			// 
			this.slave2TrackBar.Enabled = false;
			this.slave2TrackBar.LargeChange = 10;
			this.slave2TrackBar.Location = new System.Drawing.Point(104, 48);
			this.slave2TrackBar.Maximum = 100;
			this.slave2TrackBar.Minimum = 5;
			this.slave2TrackBar.Name = "slave2TrackBar";
			this.slave2TrackBar.Size = new System.Drawing.Size(112, 42);
			this.slave2TrackBar.SmallChange = 2;
			this.slave2TrackBar.TabIndex = 3;
			this.slave2TrackBar.TickFrequency = 5;
			this.slave2TrackBar.TickStyle = System.Windows.Forms.TickStyle.TopLeft;
			this.slave2TrackBar.Value = 100;
			this.slave2TrackBar.Scroll += new System.EventHandler(this.slave2TrackBar_Scroll);
			// 
			// slave2ShowTransientBtn
			// 
			this.slave2ShowTransientBtn.Enabled = false;
			this.slave2ShowTransientBtn.Location = new System.Drawing.Point(112, 96);
			this.slave2ShowTransientBtn.Name = "slave2ShowTransientBtn";
			this.slave2ShowTransientBtn.Size = new System.Drawing.Size(96, 23);
			this.slave2ShowTransientBtn.TabIndex = 1;
			this.slave2ShowTransientBtn.Text = "Show Transient";
			this.slave2ShowTransientBtn.Click += new System.EventHandler(this.slave2ShowTransientBtn_Click);
			// 
			// slave2TilePanel
			// 
			this.slave2TilePanel.Location = new System.Drawing.Point(16, 16);
			this.slave2TilePanel.Name = "slave2TilePanel";
			this.slave2TilePanel.Size = new System.Drawing.Size(70, 100);
			this.slave2TilePanel.TabIndex = 0;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(800, 465);
			this.Controls.Add(this.slave2GroupBox);
			this.Controls.Add(this.slave1GroupBox);
			this.Controls.Add(this.masterGroupBox);
			this.Menu = this.itemMenu;
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.masterGroupBox.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.masterTrackBar)).EndInit();
			this.slave1GroupBox.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.slave1TrackBar)).EndInit();
			this.slave2GroupBox.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.slave2TrackBar)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			this.masterModel.Start("master",Guid.NewGuid().ToString(),"localhost","itemtest");
		}

		private void masterModel_Started(object sender, EventArgs e)
		{
			this.masterModel.Owner.SubscribedPlace += new PlaceEventHandler(this.masterOwner_SubscribedPlace);

			// create a place to test this item
			this.masterModel.CreatePlace("Item Test Place");
		}

		private void slave1Model_Started(object sender, EventArgs e)
		{
			this.slave1ConnectBtn.Text = "Disconnect";
			this.slave1ConnectBtn.Enabled = true;
			this.slave1Model.Owner.SubscribedPlace += new PlaceEventHandler(this.slave1Owner_SubscribedPlace);
		}

		private void slave2Model_Started(object sender, EventArgs e)
		{
			this.slave2ConnectBtn.Text = "Disconnect";
			this.slave2ConnectBtn.Enabled = true;
			this.slave2Model.Owner.SubscribedPlace += new PlaceEventHandler(this.slave2Owner_SubscribedPlace);
		}

		private void masterModel_PlaceAdded(object sender, PlaceEventArgs e)
		{
			this.masterModel.Owner.SubscribePlace(e.Place);

			
			this.slave1GroupBox.Enabled = true;
			this.slave1ConnectBtn.Enabled = true;

			this.slave2GroupBox.Enabled = true;
			this.slave2ConnectBtn.Enabled = true;
		}

		private void slave1Model_PlaceAdded(object sender, PlaceEventArgs e)
		{
			this.slave1Model.Owner.SubscribePlace(e.Place);
		}

		private void slave2Model_PlaceAdded(object sender, PlaceEventArgs e)
		{
			this.slave2Model.Owner.SubscribePlace(e.Place);
		}

		private void masterOwner_SubscribedPlace(object sender, PlaceEventArgs e)
		{
			if(!this.masterPlaceSubscribed)
			{
				this.masterTestPlace = e.Place;
				this.masterGroupBox.Enabled = true;
				this.masterTestPlace.ItemAdded += new ItemEventHandler(this.masterPlace_ItemAdded);

				foreach(string itemType in this.masterModel.ItemTypes)
				{
					MenuItem im = new MenuItem(itemType);
					im.Click += new EventHandler(this.itemMenu_Click);
					this.loadItemMenu.MenuItems.Add(im);
				}
				this.loadItemMenu.Enabled = true;
				this.masterPlaceSubscribed = true;
			}
		}

		private void slave1Owner_SubscribedPlace(object sender, PlaceEventArgs e)
		{
			if(!this.slave1PlaceSubscribed)
			{
				this.slave1TestPlace = e.Place;
				this.slave1TestPlace.ItemAdded += new ItemEventHandler(this.slave1Place_ItemAdded);
				this.slave1GroupBox.Enabled = true;
				this.slave1PlaceSubscribed = true;

				if(null != this.itemKey)
				{
					// add the item
					foreach(CbModel.Item item in this.slave1TestPlace.Items)
					{
						if(item.Key == this.itemKey)
						{
							this.slave1Item = item;

							this.AddSlave1Tile();

							this.slave1ShowTransientBtn.Enabled = true;
							this.slave1TrackBar.Enabled = true;
						}
					}
					this.slave1ShowSeparateBtn.Enabled = true;
				}
			}
		}

		private void slave2Owner_SubscribedPlace(object sender, PlaceEventArgs e)
		{
			if(!this.slave2PlaceSubscribed)
			{
				this.slave2TestPlace = e.Place;
				this.slave2TestPlace.ItemAdded += new ItemEventHandler(this.slave2Place_ItemAdded);
				this.slave2GroupBox.Enabled = true;
				this.slave2PlaceSubscribed = true;

				if(null != this.itemKey)
				{
					// add the item
					foreach(CbModel.Item item in this.slave2TestPlace.Items)
					{
						if(item.Key == this.itemKey)
						{
							this.slave2Item = item;

							this.AddSlave2Tile();

							this.slave2ShowTransientBtn.Enabled = true;
							this.slave2TrackBar.Enabled = true;
						}
					}
					this.slave2ShowSeparateBtn.Enabled = true;
				}
			}
		}
		private void masterPlace_ItemAdded(object sender, ItemEventArgs e)
		{
			if(e.Item.Type == this.itemType)
			{
				this.itemKey = e.Item.Key;

				this.masterItem = e.Item;
				this.AddMasterTile();

				this.masterShowTransientBtn.Enabled = true;
				this.masterTrackBar.Enabled = true;
				this.masterShowSeparateBtn.Enabled = true;
			}
		}

		private void AddMasterTile()
		{
			Control mtile = this.masterItem.GetTile(this.masterTrackBar.Value);
			mtile.Width = this.masterTilePanel.Width;
			mtile.Height = this.masterTilePanel.Height;
			mtile.Location = new Point(0,0);
			mtile.Dock = System.Windows.Forms.DockStyle.Fill;
			this.masterTilePanel.Controls.Add(mtile);

		}		
		
		private void slave1Place_ItemAdded(object sender, ItemEventArgs e)
		{
			if(e.Item.Key == this.itemKey)
			{
				this.slave1Item = e.Item;
				this.AddSlave1Tile();

				this.slave1ShowTransientBtn.Enabled = true;
				this.slave1TrackBar.Enabled = true;
			}
		}

		private void slave2Place_ItemAdded(object sender, ItemEventArgs e)
		{
			if(e.Item.Key == this.itemKey)
			{
				this.slave2Item = e.Item;
				this.AddSlave2Tile();

				this.slave2ShowTransientBtn.Enabled = true;
				this.slave2TrackBar.Enabled = true;
			}
		}

		private void AddSlave1Tile()
		{
			Control stile = this.slave1Item.GetTile(this.slave1TrackBar.Value);
			stile.Width = this.slave1TilePanel.Width;
			stile.Height = this.slave1TilePanel.Height;
			stile.Location = new Point(0,0);
			stile.Dock = System.Windows.Forms.DockStyle.Fill;

			this.slave1TilePanel.Controls.Add(stile);	
		}

		private void AddSlave2Tile()
		{
			Control stile = this.slave2Item.GetTile(this.slave1TrackBar.Value);
			stile.Width = this.slave2TilePanel.Width;
			stile.Height = this.slave2TilePanel.Height;
			stile.Location = new Point(0,0);
			stile.Dock = System.Windows.Forms.DockStyle.Fill;

			this.slave2TilePanel.Controls.Add(stile);	
		}
		private void itemMenu_Click(object sender, EventArgs e)
		{
			string itemType = ((MenuItem)sender).Text;
			this.itemType = itemType;
			this.masterTestPlace.CreateItem(itemType);
			this.loadItemMenu.Enabled = false;
		}

		private void masterShowTransientBtn_Click(object sender, System.EventArgs e)
		{
			if(this.masterTransientVisible)
			{
				this.masterTransientPanel.Controls.Clear();
				this.masterShowTransientBtn.Text = "Show Transient";
			}
			else
			{
				Control mtransient = this.masterItem.GetTransientFocus(this.masterTransientPanel.Size);
				mtransient.Size = this.masterTransientPanel.Size;

				this.masterTransientPanel.Controls.Add(mtransient);
				this.masterShowTransientBtn.Text = "Hide Transient";
			}
			this.masterTransientVisible = !this.masterTransientVisible;
		}

		private void slave1ShowTransientBtn_Click(object sender, System.EventArgs e)
		{
			if(this.slave1TransientVisible)
			{
				this.slave1TransientPanel.Controls.Clear();
				this.slave1ShowTransientBtn.Text = "Show Transient";
			}
			else
			{
				Control stransient = this.slave1Item.GetTransientFocus(this.slave1TransientPanel.Size);
				stransient.Size = this.slave1TransientPanel.Size;

				this.slave1TransientPanel.Controls.Add(stransient);
				this.slave1ShowTransientBtn.Text = "Hide Transient";
			}
			this.slave1TransientVisible = !this.slave1TransientVisible;
		}

		private void slave2ShowTransientBtn_Click(object sender, System.EventArgs e)
		{
			if(this.slave2TransientVisible)
			{
				this.slave2TransientPanel.Controls.Clear();
				this.slave2ShowTransientBtn.Text = "Show Transient";
			}
			else
			{
				Control stransient = this.slave2Item.GetTransientFocus(this.slave2TransientPanel.Size);
				stransient.Size = this.slave2TransientPanel.Size;

				this.slave2TransientPanel.Controls.Add(stransient);
				this.slave2ShowTransientBtn.Text = "Hide Transient";
			}
			this.slave2TransientVisible = !this.slave2TransientVisible;
		}

		private void masterShowSeparateBtn_Click(object sender, System.EventArgs e)
		{
			this.masterItem.SeparateItem();
		}

		private void slave1ShowSeparateBtn_Click(object sender, System.EventArgs e)
		{
			this.slave1Item.SeparateItem();
		}

		private void slave2ShowSeparateBtn_Click(object sender, System.EventArgs e)
		{
			this.slave2Item.SeparateItem();
		}

		private void masterTrackBar_Scroll(object sender, System.EventArgs e)
		{
			this.masterTilePanel.Controls.Clear();

			this.masterTilePanel.Height = this.masterTrackBar.Value;

			this.AddMasterTile();
		}

		private void slave1TrackBar_Scroll(object sender, System.EventArgs e)
		{
			this.slave1TilePanel.Controls.Clear();

			this.slave1TilePanel.Height = this.slave1TrackBar.Value;

			this.AddSlave1Tile();		
		}

		private void slave2TrackBar_Scroll(object sender, System.EventArgs e)
		{
			this.slave2TilePanel.Controls.Clear();

			this.slave2TilePanel.Height = this.slave2TrackBar.Value;

			this.AddSlave2Tile();		
		}

		private void slave1ConnectBtn_Click(object sender, System.EventArgs e)
		{
			if(null == this.slave1Model.Owner)
			{
				this.slave1ConnectBtn.Enabled = false;
				this.slave1Model.Start("slave 1", Guid.NewGuid().ToString(), "localhost", "itemtest");		
			}
			else
			{
				this.slave1ConnectBtn.Enabled = false;
				this.slave1Model.Stop();
			}		
		}

		private void slave2ConnectBtn_Click(object sender, System.EventArgs e)
		{
			if(null == this.slave2Model.Owner)
			{
				this.slave2ConnectBtn.Enabled = false;
				this.slave2Model.Start("slave 2", Guid.NewGuid().ToString(), "localhost", "itemtest");		
			}
			else
			{
				this.slave2ConnectBtn.Enabled = false;
				this.slave2Model.Stop();
			}
		}

		private void slave1Model_Stopped(object sender, EventArgs e)
		{
			this.slave1ConnectBtn.Text = "Connect";
			this.slave1ConnectBtn.Enabled = true;

			this.slave1TilePanel.Controls.Clear();
			this.slave1TransientPanel.Controls.Clear();
			this.slave1Item = null;

			this.slave1PlaceSubscribed = false;
			this.slave1TransientVisible = false;

			this.slave1Model = new MainModel();
			this.slave1Model.SynchronizingObject = this;
			this.slave1Model.Started += new EventHandler(this.slave1Model_Started);
			this.slave1Model.PlaceAdded += new PlaceEventHandler(this.slave1Model_PlaceAdded);
			this.slave1Model.Stopped += new EventHandler(this.slave1Model_Stopped);
		}

		private void slave2Model_Stopped(object sender, EventArgs e)
		{
			this.slave2ConnectBtn.Text = "Connect";
			this.slave2ConnectBtn.Enabled = true;

			this.slave2TilePanel.Controls.Clear();
			this.slave2TransientPanel.Controls.Clear();
			this.slave2Item = null;

			this.slave2PlaceSubscribed = false;
			this.slave2TransientVisible = false;

			this.slave2Model = new MainModel();
			this.slave2Model.SynchronizingObject = this;
			this.slave2Model.Started += new EventHandler(this.slave2Model_Started);
			this.slave2Model.PlaceAdded += new PlaceEventHandler(this.slave2Model_PlaceAdded);
			this.slave2Model.Stopped += new EventHandler(this.slave2Model_Stopped);
		}
	}
}
