using System;
using SideItem;
using ColourGenerator;

namespace InvitationItem
{
	/// <summary>
	/// Summary description for InvitationItem.
	/// </summary>
	public class InvitationItem : SideItem.IItem
	{
		InvitationTile tile;
		InvitationTransient transient;

		ColourGenerator.ColourGenerator colour;

		string ownerKey;

		public InvitationItem()
		{}

		#region IItem Members

		public void SeparateItem()
		{
			// what should this look like?
		}

		public System.Windows.Forms.Control GetTransientFocus(System.Drawing.Size size)
		{
			return this.transient;
		}

		public void StopItem()
		{
			
		}

		public System.Windows.Forms.Control GetTile(int focus)
		{
			this.tile.Height = focus;
			return this.tile;
		}

		public void StartItem(GroupLab.Networking.SharedDictionary sd, string path, bool master, string inviteeKey)
		{
			int slashIndex = path.LastIndexOf("/invited");
			string placeKey = path.Substring(0,slashIndex);

			GroupLab.Networking.Map seedcolour = sd[placeKey+"/colour"] as GroupLab.Networking.Map;
			this.colour = new ColourGenerator.ColourGenerator(System.Drawing.Color.FromArgb((int)seedcolour["red"], (int)seedcolour["green"], (int)seedcolour["blue"]));

			this.tile = new InvitationTile(this);

			ownerKey = (sd[path] as GroupLab.Networking.Map)["owner"] as string;
			this.transient = new InvitationTransient(sd, this, placeKey, ownerKey, inviteeKey);
		}

		public event SideItem.ChangeEventHandler ItemChanged;
		
		#endregion

		public ColourGenerator.ColourGenerator Colour
		{
			get
			{
				return this.colour;
			}
		}
	}
}
