using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace InvitationItem
{
	/// <summary>
	/// Summary description for InvitationTransient.
	/// </summary>
	public class InvitationTransient : System.Windows.Forms.UserControl
	{
		private System.Windows.Forms.Button acceptBtn;
		private System.Windows.Forms.Label inviteLbl;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		GroupLab.Networking.SharedDictionary sd;
		string placeKey;
		string ownerKey;
		private System.Windows.Forms.Button declineBtn;
		string currentUserKey;

		InvitationItem item;

		public InvitationTransient(GroupLab.Networking.SharedDictionary sd, InvitationItem item, string placeKey, string ownerKey, string currentUserKey)
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			this.sd = sd;
			this.item = item;
			this.placeKey = placeKey;
			this.ownerKey = ownerKey;
			this.currentUserKey = currentUserKey;

			string placeName = this.sd[this.placeKey] as string;
			string ownerName = this.sd[this.ownerKey] as string;
			this.inviteLbl.Text = ownerName + " has invited you to join the " + placeName + " place.\n\n";
			this.inviteLbl.Text += "Do you want to Accept or Decline the invitation?";

			this.BackColor = this.item.Colour.BaseColour;
			this.acceptBtn.BackColor = this.item.Colour.DarkColour;
			this.acceptBtn.ForeColor = this.item.Colour.BaseColour;
			this.declineBtn.BackColor = this.item.Colour.DarkColour;
			this.declineBtn.ForeColor = this.item.Colour.BaseColour;
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.acceptBtn = new System.Windows.Forms.Button();
			this.declineBtn = new System.Windows.Forms.Button();
			this.inviteLbl = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// acceptBtn
			// 
			this.acceptBtn.Font = new System.Drawing.Font("Tahoma", 6.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.acceptBtn.Location = new System.Drawing.Point(8, 120);
			this.acceptBtn.Name = "acceptBtn";
			this.acceptBtn.Size = new System.Drawing.Size(64, 23);
			this.acceptBtn.TabIndex = 0;
			this.acceptBtn.Text = "Accept";
			this.acceptBtn.Click += new System.EventHandler(this.acceptBtn_Click);
			// 
			// declineBtn
			// 
			this.declineBtn.Font = new System.Drawing.Font("Tahoma", 6.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.declineBtn.Location = new System.Drawing.Point(80, 120);
			this.declineBtn.Name = "declineBtn";
			this.declineBtn.Size = new System.Drawing.Size(64, 23);
			this.declineBtn.TabIndex = 1;
			this.declineBtn.Text = "Decline";
			this.declineBtn.Click += new System.EventHandler(this.declineBtn_Click);
			// 
			// inviteLbl
			// 
			this.inviteLbl.Dock = System.Windows.Forms.DockStyle.Top;
			this.inviteLbl.Font = new System.Drawing.Font("Tahoma", 6.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.inviteLbl.Location = new System.Drawing.Point(0, 0);
			this.inviteLbl.Name = "inviteLbl";
			this.inviteLbl.Size = new System.Drawing.Size(150, 104);
			this.inviteLbl.TabIndex = 2;
			this.inviteLbl.Text = "label1";
			// 
			// InvitationTransient
			// 
			this.BackColor = System.Drawing.Color.PowderBlue;
			this.Controls.Add(this.inviteLbl);
			this.Controls.Add(this.declineBtn);
			this.Controls.Add(this.acceptBtn);
			this.Name = "InvitationTransient";
			this.ResumeLayout(false);

		}
		#endregion

		private void acceptBtn_Click(object sender, System.EventArgs e)
		{
			this.RemoveInvitation();
			// current user joins the group
			this.sd[this.placeKey+"/member/"+Guid.NewGuid().ToString()] = this.currentUserKey;
		}

		private void declineBtn_Click(object sender, System.EventArgs e)
		{
			// uninvite the current user
			this.RemoveInvitation();
		}

		private void RemoveInvitation()
		{
			// remove the current user from the invitees list
			ArrayList keys = new ArrayList();
			foreach(GroupLab.Networking.SharedDictionary.Entry invite in (this.sd[this.placeKey+"/invited/?"] as IEnumerable))
			{
				if(((invite.Value as GroupLab.Networking.Map)["invitee"] as string) == this.currentUserKey)
				{
					keys.Add(invite.Path);
				}
			}
			foreach(string key in keys)
			{
				if(this.sd.Contains(key))
				{
					this.sd.Remove(key);
				}
			}
		}
	}
}
