using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace ItemTemplate
{
	/// <summary>
	/// Summary description for Separate.
	/// </summary
	public class Separate : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.PictureBox picAIBO;
		private System.Windows.Forms.Label lblNeck;
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.TrackBar trackBar1;
		private System.Windows.Forms.PictureBox picWalk;

		private bool Looking = false;
		private bool Walking = false;

		private int controlSpacer = 5;
		private int groupSpacer = 20;
		Graphics walkGraph;
		private float walkTurnScale = 0.5F;
		System.Drawing.Point walkPt;  // Relative to center, 0..1
		System.Drawing.Pen walkPen;
		private int AIBOWidth = 20;  // set
		private int AIBOHeight;  // Calculated

		Graphics videoGraph;
		Image videoImage;
		System.Drawing.Point lookPt;  // Relative to top/left
		bool lookPtExists = false;
		int lookPtSize = 5;
		System.Drawing.Pen lookPtPen;
		System.Drawing.Pen crossHairPen;
		private System.Windows.Forms.Button btnBark;
		private System.Windows.Forms.Button btnHowl;
		private System.Windows.Forms.Button btnGrowl;
		private System.Windows.Forms.Button btnWhimper;

		// a pointer back to the main object 
		// don't forget to change ItemTemplate to whatever you call it!
		protected ItemTemplate main; 

		public Separate()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
		}

		public Separate(ItemTemplate main)
		{
			InitializeComponent();
			this.main = main;

			// You can delete this.
			//this.BackColor = System.Drawing.Color.Goldenrod;
			this.pictureBox1.Top = 0;
			this.pictureBox1.Left = 0;
			this.pictureBox1.SizeMode = PictureBoxSizeMode.Normal;
			this.pictureBox1.Width = 640;
			this.pictureBox1.Height = 480;
			
			videoGraph = this.pictureBox1.CreateGraphics();

			Looking = false;

			crossHairPen = new System.Drawing.Pen(System.Drawing.Color.FromArgb(127,27,200,27), 7);
			crossHairPen.DashPattern = new float[]{0.5F, 0.5F, 0.5F, 0.5F};
			
			lookPtPen = new System.Drawing.Pen(System.Drawing.Color.FromArgb(200,200,27,27), 2);

			walkPen = new System.Drawing.Pen(System.Drawing.Color.FromArgb(127,27,27,200), 7);
			walkPen.DashStyle = System.Drawing.Drawing2D.DashStyle.Dash;
			walkPen.DashPattern = new float[]{0.5F, 0.5F, 0.5F, 0.5F};

			this.picWalk = new System.Windows.Forms.PictureBox();
			this.picWalk.MouseUp += new System.Windows.Forms.MouseEventHandler(this.picWalk_MouseUp);
			this.picWalk.MouseMove += new System.Windows.Forms.MouseEventHandler(this.picWalk_MouseMove);
			this.picWalk.MouseDown += new System.Windows.Forms.MouseEventHandler(this.picWalk_MouseDown);
			
			this.Controls.Add(this.picWalk);
			this.picWalk.SendToBack();
			this.picWalk.SizeMode = PictureBoxSizeMode.Normal;
			walkGraph = this.picWalk.CreateGraphics();

			Image I = picAIBO.Image;
			AIBOHeight = (int)( (float)I.Height/(float)I.Width*(float)AIBOWidth);
		}
		
		public void FormLayout() 
		{
			picWalk.Width = pictureBox1.Width = videoImage.Width;
			picWalk.Height = pictureBox1.Height = videoImage.Height;	
			walkGraph.Dispose();
			walkGraph = this.picWalk.CreateGraphics();

			pictureBox1.Left = groupSpacer;
			lblNeck.Left = trackBar1.Left = pictureBox1.Right + controlSpacer;
			picWalk.Left = trackBar1.Right + (int)(controlSpacer*2.7F);
			
			this.Width = picWalk.Right + (int)(groupSpacer*1.7F);

			picWalk.Top = pictureBox1.Top = lblNeck.Top = groupSpacer;
			trackBar1.Top = lblNeck.Bottom;
			trackBar1.Height = pictureBox1.Height - lblNeck.Height;

            btnHowl.Top = btnBark.Top = btnWhimper.Top = btnGrowl.Top = 
				picWalk.Bottom + groupSpacer*2;

			btnHowl.Left = groupSpacer;
			btnBark.Left = btnHowl.Right + (int)(controlSpacer*1.1F);
			btnWhimper.Left = btnBark.Right + (int)(controlSpacer*1.1F);
			btnGrowl.Left = btnWhimper.Right + (int)(controlSpacer*1.1F);

			this.Height = btnGrowl.Bottom + groupSpacer*2;
			
			walkPt = new Point(picWalk.Width/2, picWalk.Height/2);
		}

		public void DrawImage() 
		{
			if (videoImage == null)
				return;
			
			Graphics offscreen = Graphics.FromImage(videoImage);
			int midX = videoImage.Width / 2;
			int midY = videoImage.Height / 2;
			offscreen.DrawLine(crossHairPen, midX, midY, midX, 0);
			offscreen.DrawLine(crossHairPen, midX, midY, midX, videoImage.Height-1);
			offscreen.DrawLine(crossHairPen, midX, midY, 0, midY);
			offscreen.DrawLine(crossHairPen, midX, midY, videoImage.Width-1, midY);
			if (lookPtExists) 
				offscreen.DrawEllipse(lookPtPen, lookPt.X-lookPtSize, lookPt.Y-lookPtSize,
					lookPtSize*2, lookPtSize*2);
			videoGraph.DrawImage(videoImage, 0,0,videoImage.Width, videoImage.Height); 

			offscreen.Dispose();
			
			Bitmap walkImage = new Bitmap(picWalk.Width, picWalk.Height);
			midX = picWalk.Width /2;
			midY = picWalk.Height /2;
			offscreen = Graphics.FromImage(walkImage);
			offscreen.Clear(this.BackColor);
			offscreen.DrawLine(walkPen, midX, midY, midX, 0);
			offscreen.DrawLine(walkPen, midX, midY, midX, picWalk.Height);
			offscreen.DrawLine(walkPen, midX, midY, 0, midY);
			offscreen.DrawLine(walkPen, midX, midY, picWalk.Width, midY);
			offscreen.DrawRectangle(System.Drawing.Pens.Black,0,0,picWalk.Width-1,picWalk.Height-1);
			midX = AIBOWidth/2;
			midY = AIBOHeight/2;

			offscreen.DrawImage(picAIBO.Image, walkPt.X-midX,walkPt.Y-midY,
				AIBOWidth,AIBOHeight);
			walkGraph.DrawImage(walkImage, 0, 0, walkImage.Width, walkImage.Height);
			offscreen.Dispose();

		}

		private static int SettingImage = 0;
		public void SetImage(System.Drawing.Image image) 
		{
			//while (0 != System.Threading.Interlocked.Exchange(ref SettingImage, 1)) 
		{
			if (videoImage == null || image.Width != videoImage.Width) 
			{
				videoImage = image;
				FormLayout();	
			}
			// only update on size change
			videoImage = image;
			DrawImage();
			//System.Threading.Interlocked.Exchange(ref SettingImage, 0);
		}
		}

		#region Dispose
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					walkPen.Dispose();
					crossHairPen.Dispose();
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		#endregion

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Separate));
			this.picAIBO = new System.Windows.Forms.PictureBox();
			this.lblNeck = new System.Windows.Forms.Label();
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.trackBar1 = new System.Windows.Forms.TrackBar();
			this.btnBark = new System.Windows.Forms.Button();
			this.btnHowl = new System.Windows.Forms.Button();
			this.btnGrowl = new System.Windows.Forms.Button();
			this.btnWhimper = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.trackBar1)).BeginInit();
			this.SuspendLayout();
			// 
			// picAIBO
			// 
			this.picAIBO.Image = ((System.Drawing.Image)(resources.GetObject("picAIBO.Image")));
			this.picAIBO.Location = new System.Drawing.Point(24, 8);
			this.picAIBO.Name = "picAIBO";
			this.picAIBO.Size = new System.Drawing.Size(1, 1);
			this.picAIBO.TabIndex = 7;
			this.picAIBO.TabStop = false;
			this.picAIBO.Visible = false;
			// 
			// lblNeck
			// 
			this.lblNeck.BackColor = System.Drawing.Color.Transparent;
			this.lblNeck.Location = new System.Drawing.Point(168, 8);
			this.lblNeck.Name = "lblNeck";
			this.lblNeck.Size = new System.Drawing.Size(40, 12);
			this.lblNeck.TabIndex = 6;
			this.lblNeck.Text = "Neck";
			// 
			// pictureBox1
			// 
			this.pictureBox1.Location = new System.Drawing.Point(40, 8);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(136, 104);
			this.pictureBox1.TabIndex = 4;
			this.pictureBox1.TabStop = false;
			this.pictureBox1.MouseUp += new System.Windows.Forms.MouseEventHandler(this.pictureBox1_MouseUp);
			this.pictureBox1.MouseMove += new System.Windows.Forms.MouseEventHandler(this.pictureBox1_MouseMove);
			this.pictureBox1.MouseDown += new System.Windows.Forms.MouseEventHandler(this.pictureBox1_MouseDown);
			// 
			// trackBar1
			// 
			this.trackBar1.LargeChange = 20;
			this.trackBar1.Location = new System.Drawing.Point(176, 0);
			this.trackBar1.Maximum = 100;
			this.trackBar1.Name = "trackBar1";
			this.trackBar1.Orientation = System.Windows.Forms.Orientation.Vertical;
			this.trackBar1.RightToLeft = System.Windows.Forms.RightToLeft.Yes;
			this.trackBar1.Size = new System.Drawing.Size(42, 120);
			this.trackBar1.TabIndex = 5;
			this.trackBar1.TickFrequency = 10;
			this.trackBar1.Value = 100;
			// 
			// btnBark
			// 
			this.btnBark.Location = new System.Drawing.Point(96, 144);
			this.btnBark.Name = "btnBark";
			this.btnBark.Size = new System.Drawing.Size(64, 23);
			this.btnBark.TabIndex = 8;
			this.btnBark.Text = "Bark";
			this.btnBark.Click += new System.EventHandler(this.btnBark_Click);
			// 
			// btnHowl
			// 
			this.btnHowl.Location = new System.Drawing.Point(24, 144);
			this.btnHowl.Name = "btnHowl";
			this.btnHowl.Size = new System.Drawing.Size(64, 23);
			this.btnHowl.TabIndex = 9;
			this.btnHowl.Text = "Howl";
			this.btnHowl.Click += new System.EventHandler(this.btnHowl_Click);
			// 
			// btnGrowl
			// 
			this.btnGrowl.Location = new System.Drawing.Point(240, 144);
			this.btnGrowl.Name = "btnGrowl";
			this.btnGrowl.Size = new System.Drawing.Size(64, 23);
			this.btnGrowl.TabIndex = 10;
			this.btnGrowl.Text = "Growl";
			this.btnGrowl.Click += new System.EventHandler(this.btnGrowl_Click);
			// 
			// btnWhimper
			// 
			this.btnWhimper.Location = new System.Drawing.Point(168, 144);
			this.btnWhimper.Name = "btnWhimper";
			this.btnWhimper.Size = new System.Drawing.Size(64, 23);
			this.btnWhimper.TabIndex = 11;
			this.btnWhimper.Text = "Whimper";
			this.btnWhimper.Click += new System.EventHandler(this.btnWhimper_Click);
			// 
			// Separate
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 273);
			this.Controls.Add(this.btnWhimper);
			this.Controls.Add(this.btnGrowl);
			this.Controls.Add(this.btnHowl);
			this.Controls.Add(this.btnBark);
			this.Controls.Add(this.picAIBO);
			this.Controls.Add(this.lblNeck);
			this.Controls.Add(this.pictureBox1);
			this.Controls.Add(this.trackBar1);
			this.Name = "Separate";
			this.Text = "Separate";
			((System.ComponentModel.ISupportInitialize)(this.trackBar1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void pictureBox1_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			Looking = true;
			SendLookCommand(e.X, e.Y);
			lookPt = new System.Drawing.Point(e.X, e.Y);
			lookPtExists = true;
		}

		private void picWalk_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			Walking = true;
			walkPt = new Point(e.X, e.Y);
			SendWalkCommand(e.X, e.Y);
		}

		private void SendLookCommand(int X, int Y) 
		{
			if (X < 0) X = 0;  if (Y < 0) Y = 0;
			if (X > pictureBox1.Width) X = pictureBox1.Width;
			if (Y > pictureBox1.Height) Y = pictureBox1.Height;

			float x = (float)(2*X - pictureBox1.Width)/(float)pictureBox1.Width*-1;
			float y = (float)(2*Y - pictureBox1.Height)/(float)pictureBox1.Height*-1;
			main.SendHPCommand(ItemTemplate.HPPan, x);
			main.SendHPCommand(ItemTemplate.HPRoll, y);
		}

		private void SendWalkCommand(int X, int Y) 
		{
			if (X < 0) X = 0;  if (Y < 0) Y = 0;
			if (X > picWalk.Width) X = picWalk.Width;
			if (Y > picWalk.Height) Y = picWalk.Height;

			float x = (float)(2*X - picWalk.Width)/(float)picWalk.Width*-1;
			float y = (float)(2*Y - picWalk.Height)/(float)picWalk.Height*-1;
			main.SendWalkCommand(ItemTemplate.WALKFwd, y);
			main.SendWalkCommand(ItemTemplate.WALKRoto, x*walkTurnScale);
		}

		private void picWalk_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if (Walking) 
			{
				SendWalkCommand(e.X, e.Y);
				walkPt = new System.Drawing.Point(e.X, e.Y);
			}
		}

		private void picWalk_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			Walking = false;
			walkPt = new Point(picWalk.Width/2,picWalk.Height/2);
		}

		private void pictureBox1_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if (Looking) 
			{
				SendLookCommand(e.X, e.Y);
				lookPt = new System.Drawing.Point(e.X, e.Y);
			}
		}

		private void pictureBox1_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			Looking = false;
		}

		private void pictureBox1_MouseLeave(object sender, System.EventArgs e)
		{
			Looking = false;
		}

		private void trackBar1_ValueChanged(object sender, System.EventArgs e)
		{
			System.Windows.Forms.TrackBar tb = (System.Windows.Forms.TrackBar)sender;
			float v = -1*(1-(float)tb.Value/(float)tb.Maximum);
			main.SendHPCommand(ItemTemplate.HPTilt, v);
		}

		private void pictureBox1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			/*if (this.videoImage != null)
						SetImage(this.videoImage); */
		}

		private void btnHowl_Click(object sender, System.EventArgs e)
		{
			main.SendWalkCommand(ItemTemplate.WALKHowl, 1);
		}

		private void btnBark_Click(object sender, System.EventArgs e)
		{
			main.SendWalkCommand(ItemTemplate.WALKBark, 1);		
		}

		private void btnWhimper_Click(object sender, System.EventArgs e)
		{
			main.SendWalkCommand(ItemTemplate.WALKWhimper, 1);		
		}

		private void btnGrowl_Click(object sender, System.EventArgs e)
		{
			main.SendWalkCommand(ItemTemplate.WALKGrowl, 1);		
		}

	}
}
