using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace PresenceItem
{
	/// <summary>
	/// Summary description for PresenceFull.
	/// </summary>
	public class MasterPresenceFull : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel NimbusPanel;
		private System.Windows.Forms.TrackBar nimbusSlider;
		private System.Windows.Forms.Label nimbusLbl;
		private System.Windows.Forms.Panel activePanel;
		private System.Windows.Forms.Label activeExpLbl;
		private System.Windows.Forms.Panel statusPanel;
		private System.Windows.Forms.Label statusExpLbl;
		private System.Windows.Forms.Panel messagePanel;
		private System.Windows.Forms.Label messageExpLbl;
		private System.Windows.Forms.Panel picturePanel;
		private System.Windows.Forms.Panel videoPanel;
		private System.Windows.Forms.Label pictureExpLbl;
		private System.Windows.Forms.Label videoExpLbl;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		PresenceItem presence;

		System.Drawing.Color defaultColour;

		private System.Windows.Forms.Panel presencePanel;
		private System.Windows.Forms.Panel bigVideoPanel;
		private System.Windows.Forms.PictureBox bigVideoPictureBox;
		private System.Windows.Forms.Label largeVideoLbl;
		private System.Windows.Forms.Label noVideoLbl;
		private System.Windows.Forms.Panel emptyBPanel;
		private System.Windows.Forms.Panel nameBPanel;
		private System.Windows.Forms.Panel messageBPanel;
		private System.Windows.Forms.Panel pictureBPanel;
		private System.Windows.Forms.Panel videoBPanel;
		private System.Windows.Forms.CheckBox bigVideoCheckBox;

		// the tiles to display the states
		private PresenceTile statusTile;
		private PresenceTile nameTile;
		private PresenceTile messageTile;
		private PresenceTile pictureTile;
		private PresenceTile videoTile;

		private bool sliding;

		public MasterPresenceFull(PresenceItem presence)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			this.presence = presence;

			this.SetupTiles();

			this.sliding = false;

			this.BackColor = this.presence.Colour.BaseColour;

			this.bigVideoCheckBox.Checked = this.presence.AllowBigVideo;

			this.defaultColour = this.presence.Colour.BaseColour;

			this.Text = this.presence.OwnerName + " (" + this.presence.PlaceName + ")";

			this.nimbusSlider.Value = this.presence.Nimbus-15;

			this.RefreshView();
			this.presence.BigImageChanged += new EventHandler(this.presence_BigImageChanged);
			this.presence.AllowBigVideoChanged += new EventHandler(this.presence_AllowBigVideoChanged);
			this.presence.RequestBigVideo();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}

			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.NimbusPanel = new System.Windows.Forms.Panel();
			this.nimbusLbl = new System.Windows.Forms.Label();
			this.nimbusSlider = new System.Windows.Forms.TrackBar();
			this.activePanel = new System.Windows.Forms.Panel();
			this.activeExpLbl = new System.Windows.Forms.Label();
			this.emptyBPanel = new System.Windows.Forms.Panel();
			this.statusPanel = new System.Windows.Forms.Panel();
			this.nameBPanel = new System.Windows.Forms.Panel();
			this.statusExpLbl = new System.Windows.Forms.Label();
			this.messagePanel = new System.Windows.Forms.Panel();
			this.messageBPanel = new System.Windows.Forms.Panel();
			this.messageExpLbl = new System.Windows.Forms.Label();
			this.picturePanel = new System.Windows.Forms.Panel();
			this.pictureBPanel = new System.Windows.Forms.Panel();
			this.pictureExpLbl = new System.Windows.Forms.Label();
			this.videoPanel = new System.Windows.Forms.Panel();
			this.videoBPanel = new System.Windows.Forms.Panel();
			this.videoExpLbl = new System.Windows.Forms.Label();
			this.presencePanel = new System.Windows.Forms.Panel();
			this.bigVideoPanel = new System.Windows.Forms.Panel();
			this.noVideoLbl = new System.Windows.Forms.Label();
			this.largeVideoLbl = new System.Windows.Forms.Label();
			this.bigVideoCheckBox = new System.Windows.Forms.CheckBox();
			this.bigVideoPictureBox = new System.Windows.Forms.PictureBox();
			this.NimbusPanel.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.nimbusSlider)).BeginInit();
			this.activePanel.SuspendLayout();
			this.statusPanel.SuspendLayout();
			this.messagePanel.SuspendLayout();
			this.picturePanel.SuspendLayout();
			this.videoPanel.SuspendLayout();
			this.presencePanel.SuspendLayout();
			this.bigVideoPanel.SuspendLayout();
			this.SuspendLayout();
			// 
			// NimbusPanel
			// 
			this.NimbusPanel.Controls.Add(this.nimbusLbl);
			this.NimbusPanel.Controls.Add(this.nimbusSlider);
			this.NimbusPanel.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.NimbusPanel.Location = new System.Drawing.Point(0, 221);
			this.NimbusPanel.Name = "NimbusPanel";
			this.NimbusPanel.Size = new System.Drawing.Size(440, 56);
			this.NimbusPanel.TabIndex = 0;
			// 
			// nimbusLbl
			// 
			this.nimbusLbl.Dock = System.Windows.Forms.DockStyle.Fill;
			this.nimbusLbl.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.nimbusLbl.Location = new System.Drawing.Point(0, 0);
			this.nimbusLbl.Name = "nimbusLbl";
			this.nimbusLbl.Size = new System.Drawing.Size(104, 56);
			this.nimbusLbl.TabIndex = 1;
			this.nimbusLbl.Text = "Adjust the slider to control what information you present to others.";
			// 
			// nimbusSlider
			// 
			this.nimbusSlider.Dock = System.Windows.Forms.DockStyle.Right;
			this.nimbusSlider.Location = new System.Drawing.Point(104, 0);
			this.nimbusSlider.Maximum = 85;
			this.nimbusSlider.Name = "nimbusSlider";
			this.nimbusSlider.Size = new System.Drawing.Size(336, 56);
			this.nimbusSlider.TabIndex = 0;
			this.nimbusSlider.Value = 85;
			this.nimbusSlider.MouseUp += new System.Windows.Forms.MouseEventHandler(this.nimbusSlider_MouseUp);
			this.nimbusSlider.Scroll += new System.EventHandler(this.nimbusSlider_Scroll);
			// 
			// activePanel
			// 
			this.activePanel.Controls.Add(this.activeExpLbl);
			this.activePanel.Controls.Add(this.emptyBPanel);
			this.activePanel.Dock = System.Windows.Forms.DockStyle.Left;
			this.activePanel.Location = new System.Drawing.Point(0, 0);
			this.activePanel.Name = "activePanel";
			this.activePanel.Size = new System.Drawing.Size(88, 221);
			this.activePanel.TabIndex = 1;
			// 
			// activeExpLbl
			// 
			this.activeExpLbl.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.activeExpLbl.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.activeExpLbl.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.activeExpLbl.Location = new System.Drawing.Point(0, 117);
			this.activeExpLbl.Name = "activeExpLbl";
			this.activeExpLbl.Size = new System.Drawing.Size(88, 104);
			this.activeExpLbl.TabIndex = 2;
			this.activeExpLbl.Text = "Changes colour when the user is inactive.";
			// 
			// emptyBPanel
			// 
			this.emptyBPanel.BackColor = System.Drawing.Color.Black;
			this.emptyBPanel.Location = new System.Drawing.Point(8, 16);
			this.emptyBPanel.Name = "emptyBPanel";
			this.emptyBPanel.Size = new System.Drawing.Size(72, 13);
			this.emptyBPanel.TabIndex = 2;
			// 
			// statusPanel
			// 
			this.statusPanel.Controls.Add(this.nameBPanel);
			this.statusPanel.Controls.Add(this.statusExpLbl);
			this.statusPanel.Dock = System.Windows.Forms.DockStyle.Left;
			this.statusPanel.Location = new System.Drawing.Point(88, 0);
			this.statusPanel.Name = "statusPanel";
			this.statusPanel.Size = new System.Drawing.Size(88, 221);
			this.statusPanel.TabIndex = 3;
			// 
			// nameBPanel
			// 
			this.nameBPanel.BackColor = System.Drawing.Color.Black;
			this.nameBPanel.Location = new System.Drawing.Point(8, 16);
			this.nameBPanel.Name = "nameBPanel";
			this.nameBPanel.Size = new System.Drawing.Size(72, 26);
			this.nameBPanel.TabIndex = 2;
			// 
			// statusExpLbl
			// 
			this.statusExpLbl.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.statusExpLbl.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.statusExpLbl.Location = new System.Drawing.Point(0, 117);
			this.statusExpLbl.Name = "statusExpLbl";
			this.statusExpLbl.Size = new System.Drawing.Size(88, 104);
			this.statusExpLbl.TabIndex = 1;
			this.statusExpLbl.Text = "Displays the name. Changes colour when the user is inactive.";
			// 
			// messagePanel
			// 
			this.messagePanel.Controls.Add(this.messageBPanel);
			this.messagePanel.Controls.Add(this.messageExpLbl);
			this.messagePanel.Dock = System.Windows.Forms.DockStyle.Left;
			this.messagePanel.Location = new System.Drawing.Point(176, 0);
			this.messagePanel.Name = "messagePanel";
			this.messagePanel.Size = new System.Drawing.Size(88, 221);
			this.messagePanel.TabIndex = 4;
			// 
			// messageBPanel
			// 
			this.messageBPanel.BackColor = System.Drawing.Color.Black;
			this.messageBPanel.Location = new System.Drawing.Point(8, 16);
			this.messageBPanel.Name = "messageBPanel";
			this.messageBPanel.Size = new System.Drawing.Size(72, 38);
			this.messageBPanel.TabIndex = 2;
			// 
			// messageExpLbl
			// 
			this.messageExpLbl.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.messageExpLbl.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.messageExpLbl.Location = new System.Drawing.Point(0, 117);
			this.messageExpLbl.Name = "messageExpLbl";
			this.messageExpLbl.Size = new System.Drawing.Size(88, 104);
			this.messageExpLbl.TabIndex = 1;
			this.messageExpLbl.Text = "Displays the name and message. Changes colour when user is inactive.";
			// 
			// picturePanel
			// 
			this.picturePanel.Controls.Add(this.pictureBPanel);
			this.picturePanel.Controls.Add(this.pictureExpLbl);
			this.picturePanel.Dock = System.Windows.Forms.DockStyle.Left;
			this.picturePanel.Location = new System.Drawing.Point(264, 0);
			this.picturePanel.Name = "picturePanel";
			this.picturePanel.Size = new System.Drawing.Size(88, 221);
			this.picturePanel.TabIndex = 5;
			// 
			// pictureBPanel
			// 
			this.pictureBPanel.BackColor = System.Drawing.Color.Black;
			this.pictureBPanel.Location = new System.Drawing.Point(8, 16);
			this.pictureBPanel.Name = "pictureBPanel";
			this.pictureBPanel.Size = new System.Drawing.Size(72, 67);
			this.pictureBPanel.TabIndex = 2;
			// 
			// pictureExpLbl
			// 
			this.pictureExpLbl.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.pictureExpLbl.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.pictureExpLbl.Location = new System.Drawing.Point(0, 117);
			this.pictureExpLbl.Name = "pictureExpLbl";
			this.pictureExpLbl.Size = new System.Drawing.Size(88, 104);
			this.pictureExpLbl.TabIndex = 1;
			this.pictureExpLbl.Text = "Displays the name, message, and a static picture. Changes colour when the user is" +
				" inactive.";
			// 
			// videoPanel
			// 
			this.videoPanel.Controls.Add(this.videoBPanel);
			this.videoPanel.Controls.Add(this.videoExpLbl);
			this.videoPanel.Dock = System.Windows.Forms.DockStyle.Left;
			this.videoPanel.Location = new System.Drawing.Point(352, 0);
			this.videoPanel.Name = "videoPanel";
			this.videoPanel.Size = new System.Drawing.Size(88, 221);
			this.videoPanel.TabIndex = 6;
			// 
			// videoBPanel
			// 
			this.videoBPanel.BackColor = System.Drawing.Color.Black;
			this.videoBPanel.Location = new System.Drawing.Point(8, 16);
			this.videoBPanel.Name = "videoBPanel";
			this.videoBPanel.Size = new System.Drawing.Size(72, 87);
			this.videoBPanel.TabIndex = 3;
			// 
			// videoExpLbl
			// 
			this.videoExpLbl.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.videoExpLbl.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.videoExpLbl.Location = new System.Drawing.Point(0, 117);
			this.videoExpLbl.Name = "videoExpLbl";
			this.videoExpLbl.Size = new System.Drawing.Size(88, 104);
			this.videoExpLbl.TabIndex = 2;
			this.videoExpLbl.Text = "Displays the name, message, and a webcam snapshot. Changes colour when the user i" +
				"s inactive.";
			// 
			// presencePanel
			// 
			this.presencePanel.Controls.Add(this.videoPanel);
			this.presencePanel.Controls.Add(this.picturePanel);
			this.presencePanel.Controls.Add(this.messagePanel);
			this.presencePanel.Controls.Add(this.statusPanel);
			this.presencePanel.Controls.Add(this.activePanel);
			this.presencePanel.Dock = System.Windows.Forms.DockStyle.Fill;
			this.presencePanel.Location = new System.Drawing.Point(0, 0);
			this.presencePanel.Name = "presencePanel";
			this.presencePanel.Size = new System.Drawing.Size(440, 221);
			this.presencePanel.TabIndex = 7;
			// 
			// bigVideoPanel
			// 
			this.bigVideoPanel.Controls.Add(this.noVideoLbl);
			this.bigVideoPanel.Controls.Add(this.largeVideoLbl);
			this.bigVideoPanel.Controls.Add(this.bigVideoCheckBox);
			this.bigVideoPanel.Controls.Add(this.bigVideoPictureBox);
			this.bigVideoPanel.Dock = System.Windows.Forms.DockStyle.Right;
			this.bigVideoPanel.Location = new System.Drawing.Point(440, 0);
			this.bigVideoPanel.Name = "bigVideoPanel";
			this.bigVideoPanel.Size = new System.Drawing.Size(208, 277);
			this.bigVideoPanel.TabIndex = 8;
			// 
			// noVideoLbl
			// 
			this.noVideoLbl.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.noVideoLbl.Location = new System.Drawing.Point(48, 48);
			this.noVideoLbl.Name = "noVideoLbl";
			this.noVideoLbl.Size = new System.Drawing.Size(120, 64);
			this.noVideoLbl.TabIndex = 3;
			this.noVideoLbl.Text = "You have chosen not to make the large video available.";
			this.noVideoLbl.TextAlign = System.Drawing.ContentAlignment.TopCenter;
			// 
			// largeVideoLbl
			// 
			this.largeVideoLbl.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.largeVideoLbl.Location = new System.Drawing.Point(24, 216);
			this.largeVideoLbl.Name = "largeVideoLbl";
			this.largeVideoLbl.Size = new System.Drawing.Size(176, 40);
			this.largeVideoLbl.TabIndex = 2;
			this.largeVideoLbl.Text = "Yes, I want to allow others to see large, fast frame rate video of me.";
			// 
			// bigVideoCheckBox
			// 
			this.bigVideoCheckBox.Location = new System.Drawing.Point(8, 216);
			this.bigVideoCheckBox.Name = "bigVideoCheckBox";
			this.bigVideoCheckBox.Size = new System.Drawing.Size(16, 16);
			this.bigVideoCheckBox.TabIndex = 1;
			this.bigVideoCheckBox.CheckedChanged += new System.EventHandler(this.bigVideoCheckBox_CheckedChanged);
			// 
			// bigVideoPictureBox
			// 
			this.bigVideoPictureBox.Dock = System.Windows.Forms.DockStyle.Top;
			this.bigVideoPictureBox.Location = new System.Drawing.Point(0, 0);
			this.bigVideoPictureBox.Name = "bigVideoPictureBox";
			this.bigVideoPictureBox.Size = new System.Drawing.Size(208, 192);
			this.bigVideoPictureBox.SizeMode = System.Windows.Forms.PictureBoxSizeMode.CenterImage;
			this.bigVideoPictureBox.TabIndex = 0;
			this.bigVideoPictureBox.TabStop = false;
			// 
			// MasterPresenceFull
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.Color.CadetBlue;
			this.ClientSize = new System.Drawing.Size(648, 277);
			this.Controls.Add(this.presencePanel);
			this.Controls.Add(this.NimbusPanel);
			this.Controls.Add(this.bigVideoPanel);
			this.ForeColor = System.Drawing.Color.Black;
			this.Name = "MasterPresenceFull";
			this.Text = "PresenceFull";
			this.NimbusPanel.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.nimbusSlider)).EndInit();
			this.activePanel.ResumeLayout(false);
			this.statusPanel.ResumeLayout(false);
			this.messagePanel.ResumeLayout(false);
			this.picturePanel.ResumeLayout(false);
			this.videoPanel.ResumeLayout(false);
			this.presencePanel.ResumeLayout(false);
			this.bigVideoPanel.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void SetupTiles()
		{
			this.SuspendLayout();

			this.statusTile = new PresenceTile(this.presence);
			this.statusTile.OnlineColour();
			this.statusTile.Location = new Point(1,1);
			this.emptyBPanel.Controls.Add(this.statusTile);
			this.statusTile.SizeChanged += new EventHandler(this.statusTile_SizeChanged);
			this.statusTile.Size = new Size(this.emptyBPanel.Width-2, 100);

			this.nameTile = new PresenceTile(this.presence);
			this.nameTile.OnlineColour();
			this.nameTile.Location = new Point(1,1);
			this.nameBPanel.Controls.Add(this.nameTile);
			this.nameTile.SizeChanged += new EventHandler(this.nameTile_SizeChanged);
			this.nameTile.Size = new Size(this.nameBPanel.Width-2, 100);

			this.messageTile = new PresenceTile(this.presence);
			this.messageTile.OnlineColour();
			this.messageTile.Location = new Point(1,1);
			this.messageBPanel.Controls.Add(this.messageTile);
			this.messageTile.SizeChanged += new EventHandler(this.messageTile_SizeChanged);
			this.messageTile.Size = new Size(this.messageBPanel.Width-2, 100);

			this.pictureTile = new PresenceTile(this.presence);
			this.pictureTile.OnlineColour();
			this.pictureTile.Location = new Point(1,1);
			this.pictureBPanel.Controls.Add(this.pictureTile);
			this.pictureTile.SizeChanged += new EventHandler(this.pictureTile_SizeChanged);
			this.pictureTile.Size = new Size(this.pictureBPanel.Width-2, 100);

			this.videoTile = new PresenceTile(this.presence);
			this.videoTile.OnlineColour();
			this.videoTile.Location = new Point(1,1);
			this.videoBPanel.Controls.Add(this.videoTile);
			this.videoTile.SizeChanged += new EventHandler(this.videoTile_SizeChanged);
			this.videoTile.Size = new Size(this.videoBPanel.Width-2, 100);

			this.ResumeLayout(true);
		}

		private void RefreshView()
		{
			int nimbus = this.nimbusSlider.Value+15;
			if(nimbus < this.presence.NameAwareness)
			{
				// can never reach here
			} 
			else if(nimbus < this.presence.MessageAwareness)
			{
				// at maximum
				this.statusTile.Visible = true;
				this.statusTile.Nimbus = this.presence.NameAwareness-1;

				// current
				this.nameTile.Visible = true;
				this.nameTile.Nimbus = nimbus;

				// minimum and greyed out
				this.messageTile.Nimbus = this.presence.MessageAwareness;
				this.messageTile.Visible = false;
				this.pictureTile.Nimbus = this.presence.PictureAwareness;
				this.pictureTile.Visible = false;
				this.videoTile.Nimbus = this.presence.VideoAwareness;
				this.videoTile.Visible = false;
			}
			else if(nimbus < this.presence.PictureAwareness)
			{
				// at maximum
				this.statusTile.Visible = true;
				this.statusTile.Nimbus = this.presence.NameAwareness-1;
				this.nameTile.Visible = true;
				this.nameTile.Nimbus = this.presence.MessageAwareness-1;

				// current
				this.messageTile.Visible = true;
				this.messageTile.Nimbus = nimbus;

				// minimum and greyed out
				this.pictureTile.Nimbus = this.presence.PictureAwareness;
				this.pictureTile.Visible = false;
				this.videoTile.Nimbus = this.presence.VideoAwareness;
				this.videoTile.Visible = false;
			}
			else if(nimbus < this.presence.VideoAwareness)
			{
				// at maximum
				this.statusTile.Visible = true;
				this.statusTile.Nimbus = this.presence.NameAwareness-1;
				this.nameTile.Visible = true;
				this.nameTile.Nimbus = this.presence.MessageAwareness-1;
				this.messageTile.Visible = true;
				this.messageTile.Nimbus = this.presence.PictureAwareness-1;

				// current
				this.pictureTile.Nimbus = nimbus;
				this.pictureTile.Visible = true;

				// minimum and greyed out
				this.videoTile.Nimbus = this.presence.VideoAwareness;
				this.videoTile.Visible = false;
			} 
			else
			{
				// at maximum
				this.statusTile.Visible = true;
				this.statusTile.Nimbus = this.presence.NameAwareness-1;
				this.nameTile.Visible = true;
				this.nameTile.Nimbus = this.presence.MessageAwareness-1;
				this.messageTile.Visible = true;
				this.messageTile.Nimbus = this.presence.PictureAwareness-1;
				this.pictureTile.Visible = true;
				this.pictureTile.Nimbus = this.presence.VideoAwareness-1;

				// current
				this.videoTile.Nimbus = nimbus;
				this.videoTile.Visible = true;

				// minimum and greyed out
			}
		}

		private void nimbusSlider_Scroll(object sender, System.EventArgs e)
		{
			this.sliding = true;
			// TODO: make the view in this window change
			this.RefreshView();
		}

		private void videoPictureBox_Click(object sender, System.EventArgs e)
		{
			if(this.presence.Master && this.presence.Awareness >= 90)
			{
				this.presence.UpdateCamera();
			}
		}

		private void presence_BigImageChanged(object sender, EventArgs e)
		{
			if(this.presence.AllowBigVideo)
			{
				this.bigVideoPictureBox.Image = this.presence.GetBigImage(this.bigVideoPictureBox.Size);
			}
		}

		private void bigVideoCheckBox_CheckedChanged(object sender, System.EventArgs e)
		{
			this.presence.AllowBigVideo = this.bigVideoCheckBox.Checked;
		}

		private void SetLargeVideo()
		{
			if(this.presence.AllowBigVideo)
			{
				Image i = this.bigVideoPictureBox.Image;
				this.bigVideoPictureBox.Image = this.presence.GetBigImage(this.bigVideoPictureBox.Size);
				if(null != i)
				{
					i.Dispose();
				}
				this.noVideoLbl.Visible = false;
			}
			else
			{
				Image i = this.bigVideoPictureBox.Image;
				this.bigVideoPictureBox.Image = null;
				if(null != i)
				{
					i.Dispose();
				}
				this.noVideoLbl.Visible = true;
				this.noVideoLbl.BringToFront();
			}
		}

		private void presence_AllowBigVideoChanged(object sender, EventArgs e)
		{
			this.SetLargeVideo();
		}

		private void nimbusSlider_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if(this.sliding)
			{
				this.sliding = false;
				this.presence.Nimbus = this.nimbusSlider.Value+15;
			}
		}

		private void statusTile_SizeChanged(object sender, EventArgs e)
		{
			this.emptyBPanel.Height = this.statusTile.Height+2;
		}

		private void nameTile_SizeChanged(object sender, EventArgs e)
		{
			this.nameBPanel.Height = this.nameTile.Height+2;
		}

		private void messageTile_SizeChanged(object sender, EventArgs e)
		{
			this.messageBPanel.Height = this.messageTile.Height+2;
		}

		private void pictureTile_SizeChanged(object sender, EventArgs e)
		{
			this.pictureBPanel.Height = this.pictureTile.Height+2;
		}

		private void videoTile_SizeChanged(object sender, EventArgs e)
		{
			this.videoBPanel.Height = this.videoTile.Height+2;
		}
	}
}
