using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace PresenceItem
{
	/// <summary>
	/// Summary description for PresenceFull.
	/// </summary>
	public class SlavePresenceFull : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		PresenceItem presence;

		System.Drawing.Color defaultColour;

		//images
		private System.Windows.Forms.Panel bigVideoPanel;
		private System.Windows.Forms.PictureBox picturePictureBox;
		private System.Windows.Forms.Panel otherPanel;
		private System.Windows.Forms.Label statusLbl;
		private System.Windows.Forms.Label messageLbl;
		private System.Windows.Forms.Label noVideoLbl;
		private System.Windows.Forms.Button talkBtn;
		private System.Windows.Forms.PictureBox bigVideoPictureBox;
		private System.Windows.Forms.Panel ownerAwarePnl;
		private System.Windows.Forms.Label ownerAwareLbl;
		private System.Windows.Forms.Label ownerAwareValueLbl;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Panel ownerAwareDisplayPnl;
		private System.Windows.Forms.Label ownerAwareDisplayLbl;

		Collabrary.Microphone mic;

		public SlavePresenceFull(PresenceItem presence)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			this.noVideoLbl.Visible = false;

			this.presence = presence;

			this.defaultColour = this.presence.Colour.PresenceColour;
			this.talkBtn.BackColor = this.presence.Colour.DarkColour;
			this.talkBtn.ForeColor = this.presence.Colour.PresenceColour;
			this.BackColor = this.presence.Colour.PresenceColour;
			this.bigVideoPictureBox.BackColor = this.presence.Colour.PresenceColour;
			this.picturePictureBox.BackColor = this.presence.Colour.PresenceColour;
			this.noVideoLbl.BackColor = this.presence.Colour.PresenceColour;
			if(this.presence.IsDisplayAwareness)
			{
				this.ownerAwareLbl.BackColor = this.presence.Colour.PresenceColour;
				this.ownerAwareValueLbl.BackColor = this.presence.Colour.PresenceColour;
				this.ownerAwareDisplayPnl.BackColor = this.presence.Colour.PresenceColour;
				this.ownerAwareDisplayLbl.BackColor = this.presence.Colour.DarkColour;
				this.presence.OwnerAwarenessChanged += new EventHandler(this.presence_OwnerAwarenessChanged);
				this.presence_OwnerAwarenessChanged(null, new EventArgs());
			}

			this.presence_StatusChanged(this.presence, new EventArgs());

			this.Text = this.presence.OwnerName + " (" + this.presence.PlaceName + ")";

			this.InitValues();

			this.SetVideo();

			this.presence.RequestBigVideo();

			this.presence.NimbusChanged += new EventHandler(this.presence_NimbusChanged);
			this.presence.StatusChanged += new EventHandler(this.presence_StatusChanged);
			this.presence.MessageChanged += new EventHandler(this.presence_MessageChanged);
			this.presence.PictureChanged += new EventHandler(this.presence_PictureChanged);
			this.presence.BigImageChanged += new EventHandler(this.presence_BigImageChanged);
			this.presence.AllowBigVideoChanged += new EventHandler(this.presence_AllowBigVideoChanged);
		}

		private void InitValues()
		{
			this.SetStatus(this.presence.Status);
			this.SetMessage(this.presence.Message);
			this.picturePictureBox.Image = this.presence.GetPicture(this.picturePictureBox.Size);
			Image i = this.bigVideoPictureBox.Image;
			this.bigVideoPictureBox.Image = this.presence.GetBigImage(this.bigVideoPictureBox.Size);
			if(null != i)
			{
				i.Dispose();
			}
		}

		private void SetVideo()
		{
			Image i = this.bigVideoPictureBox.Image;
			if(this.presence.AllowBigVideo)
			{
				this.bigVideoPictureBox.Image = this.presence.GetBigImage(this.bigVideoPictureBox.Size);
				this.noVideoLbl.Visible = false;
			}
			else
			{
				this.bigVideoPictureBox.Image = null;
				this.noVideoLbl.Visible = true;
				this.noVideoLbl.BringToFront();
			}
			if(i != null)
			{
				i.Dispose();
			}
		}


		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			this.presence.NimbusChanged -= new EventHandler(this.presence_NimbusChanged);
			this.presence.StatusChanged -= new EventHandler(this.presence_StatusChanged);
			this.presence.MessageChanged -= new EventHandler(this.presence_MessageChanged);
			this.presence.PictureChanged -= new EventHandler(this.presence_PictureChanged);
			this.presence.BigImageChanged -= new EventHandler(this.presence_BigImageChanged);
			this.presence.AllowBigVideoChanged -= new EventHandler(this.presence_AllowBigVideoChanged);

			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.bigVideoPanel = new System.Windows.Forms.Panel();
			this.noVideoLbl = new System.Windows.Forms.Label();
			this.bigVideoPictureBox = new System.Windows.Forms.PictureBox();
			this.picturePictureBox = new System.Windows.Forms.PictureBox();
			this.otherPanel = new System.Windows.Forms.Panel();
			this.messageLbl = new System.Windows.Forms.Label();
			this.statusLbl = new System.Windows.Forms.Label();
			this.talkBtn = new System.Windows.Forms.Button();
			this.ownerAwarePnl = new System.Windows.Forms.Panel();
			this.ownerAwareLbl = new System.Windows.Forms.Label();
			this.ownerAwareValueLbl = new System.Windows.Forms.Label();
			this.panel1 = new System.Windows.Forms.Panel();
			this.panel2 = new System.Windows.Forms.Panel();
			this.ownerAwareDisplayPnl = new System.Windows.Forms.Panel();
			this.ownerAwareDisplayLbl = new System.Windows.Forms.Label();
			this.bigVideoPanel.SuspendLayout();
			this.otherPanel.SuspendLayout();
			this.ownerAwarePnl.SuspendLayout();
			this.panel2.SuspendLayout();
			this.ownerAwareDisplayPnl.SuspendLayout();
			this.SuspendLayout();
			// 
			// bigVideoPanel
			// 
			this.bigVideoPanel.Controls.Add(this.noVideoLbl);
			this.bigVideoPanel.Controls.Add(this.bigVideoPictureBox);
			this.bigVideoPanel.Controls.Add(this.ownerAwarePnl);
			this.bigVideoPanel.Controls.Add(this.panel1);
			this.bigVideoPanel.Dock = System.Windows.Forms.DockStyle.Left;
			this.bigVideoPanel.Location = new System.Drawing.Point(0, 0);
			this.bigVideoPanel.Name = "bigVideoPanel";
			this.bigVideoPanel.Size = new System.Drawing.Size(320, 253);
			this.bigVideoPanel.TabIndex = 8;
			// 
			// noVideoLbl
			// 
			this.noVideoLbl.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.noVideoLbl.Location = new System.Drawing.Point(96, 120);
			this.noVideoLbl.Name = "noVideoLbl";
			this.noVideoLbl.Size = new System.Drawing.Size(100, 32);
			this.noVideoLbl.TabIndex = 1;
			this.noVideoLbl.Text = "Large video is not available.";
			this.noVideoLbl.TextAlign = System.Drawing.ContentAlignment.TopCenter;
			// 
			// bigVideoPictureBox
			// 
			this.bigVideoPictureBox.BackColor = System.Drawing.Color.DimGray;
			this.bigVideoPictureBox.Dock = System.Windows.Forms.DockStyle.Fill;
			this.bigVideoPictureBox.Location = new System.Drawing.Point(0, 56);
			this.bigVideoPictureBox.Name = "bigVideoPictureBox";
			this.bigVideoPictureBox.Size = new System.Drawing.Size(320, 197);
			this.bigVideoPictureBox.SizeMode = System.Windows.Forms.PictureBoxSizeMode.CenterImage;
			this.bigVideoPictureBox.TabIndex = 0;
			this.bigVideoPictureBox.TabStop = false;
			// 
			// picturePictureBox
			// 
			this.picturePictureBox.Dock = System.Windows.Forms.DockStyle.Fill;
			this.picturePictureBox.Location = new System.Drawing.Point(0, 56);
			this.picturePictureBox.Name = "picturePictureBox";
			this.picturePictureBox.Size = new System.Drawing.Size(184, 197);
			this.picturePictureBox.SizeMode = System.Windows.Forms.PictureBoxSizeMode.CenterImage;
			this.picturePictureBox.TabIndex = 1;
			this.picturePictureBox.TabStop = false;
			// 
			// otherPanel
			// 
			this.otherPanel.Controls.Add(this.picturePictureBox);
			this.otherPanel.Controls.Add(this.messageLbl);
			this.otherPanel.Controls.Add(this.statusLbl);
			this.otherPanel.Dock = System.Windows.Forms.DockStyle.Fill;
			this.otherPanel.Location = new System.Drawing.Point(320, 0);
			this.otherPanel.Name = "otherPanel";
			this.otherPanel.Size = new System.Drawing.Size(184, 253);
			this.otherPanel.TabIndex = 9;
			// 
			// messageLbl
			// 
			this.messageLbl.BackColor = System.Drawing.Color.DarkGray;
			this.messageLbl.Dock = System.Windows.Forms.DockStyle.Top;
			this.messageLbl.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.messageLbl.Location = new System.Drawing.Point(0, 24);
			this.messageLbl.Name = "messageLbl";
			this.messageLbl.Size = new System.Drawing.Size(184, 32);
			this.messageLbl.TabIndex = 3;
			this.messageLbl.TextAlign = System.Drawing.ContentAlignment.TopCenter;
			// 
			// statusLbl
			// 
			this.statusLbl.BackColor = System.Drawing.Color.Gray;
			this.statusLbl.Dock = System.Windows.Forms.DockStyle.Top;
			this.statusLbl.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.statusLbl.Location = new System.Drawing.Point(0, 0);
			this.statusLbl.Name = "statusLbl";
			this.statusLbl.Size = new System.Drawing.Size(184, 24);
			this.statusLbl.TabIndex = 2;
			this.statusLbl.Text = "<status>";
			this.statusLbl.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// talkBtn
			// 
			this.talkBtn.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.talkBtn.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.talkBtn.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.talkBtn.Location = new System.Drawing.Point(0, 253);
			this.talkBtn.Name = "talkBtn";
			this.talkBtn.Size = new System.Drawing.Size(504, 48);
			this.talkBtn.TabIndex = 2;
			this.talkBtn.Text = "Push to Talk";
			this.talkBtn.MouseUp += new System.Windows.Forms.MouseEventHandler(this.talkBtn_MouseUp);
			this.talkBtn.MouseDown += new System.Windows.Forms.MouseEventHandler(this.talkBtn_MouseDown);
			// 
			// ownerAwarePnl
			// 
			this.ownerAwarePnl.Controls.Add(this.panel2);
			this.ownerAwarePnl.Controls.Add(this.ownerAwareLbl);
			this.ownerAwarePnl.Controls.Add(this.ownerAwareValueLbl);
			this.ownerAwarePnl.Dock = System.Windows.Forms.DockStyle.Top;
			this.ownerAwarePnl.Location = new System.Drawing.Point(0, 0);
			this.ownerAwarePnl.Name = "ownerAwarePnl";
			this.ownerAwarePnl.Size = new System.Drawing.Size(320, 56);
			this.ownerAwarePnl.TabIndex = 2;
			// 
			// ownerAwareLbl
			// 
			this.ownerAwareLbl.Dock = System.Windows.Forms.DockStyle.Right;
			this.ownerAwareLbl.Location = new System.Drawing.Point(168, 0);
			this.ownerAwareLbl.Name = "ownerAwareLbl";
			this.ownerAwareLbl.Size = new System.Drawing.Size(152, 32);
			this.ownerAwareLbl.TabIndex = 0;
			this.ownerAwareLbl.Text = "The bar indicates how much this person is viewing you.";
			// 
			// ownerAwareValueLbl
			// 
			this.ownerAwareValueLbl.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.ownerAwareValueLbl.Location = new System.Drawing.Point(0, 32);
			this.ownerAwareValueLbl.Name = "ownerAwareValueLbl";
			this.ownerAwareValueLbl.Size = new System.Drawing.Size(320, 24);
			this.ownerAwareValueLbl.TabIndex = 3;
			this.ownerAwareValueLbl.Text = "Currently viewing your video";
			this.ownerAwareValueLbl.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// panel1
			// 
			this.panel1.Location = new System.Drawing.Point(232, 96);
			this.panel1.Name = "panel1";
			this.panel1.TabIndex = 4;
			// 
			// panel2
			// 
			this.panel2.BackColor = System.Drawing.Color.Black;
			this.panel2.Controls.Add(this.ownerAwareDisplayPnl);
			this.panel2.Location = new System.Drawing.Point(5, 5);
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(160, 27);
			this.panel2.TabIndex = 10;
			// 
			// ownerAwareDisplayPnl
			// 
			this.ownerAwareDisplayPnl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.ownerAwareDisplayPnl.BackColor = System.Drawing.Color.SkyBlue;
			this.ownerAwareDisplayPnl.Controls.Add(this.ownerAwareDisplayLbl);
			this.ownerAwareDisplayPnl.Location = new System.Drawing.Point(1, 1);
			this.ownerAwareDisplayPnl.Name = "ownerAwareDisplayPnl";
			this.ownerAwareDisplayPnl.Size = new System.Drawing.Size(158, 25);
			this.ownerAwareDisplayPnl.TabIndex = 0;
			// 
			// ownerAwareDisplayLbl
			// 
			this.ownerAwareDisplayLbl.Dock = System.Windows.Forms.DockStyle.Left;
			this.ownerAwareDisplayLbl.Location = new System.Drawing.Point(0, 0);
			this.ownerAwareDisplayLbl.Name = "ownerAwareDisplayLbl";
			this.ownerAwareDisplayLbl.Size = new System.Drawing.Size(100, 25);
			this.ownerAwareDisplayLbl.TabIndex = 5;
			// 
			// SlavePresenceFull
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.BackColor = System.Drawing.Color.SkyBlue;
			this.ClientSize = new System.Drawing.Size(504, 301);
			this.Controls.Add(this.otherPanel);
			this.Controls.Add(this.bigVideoPanel);
			this.Controls.Add(this.talkBtn);
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.ForeColor = System.Drawing.Color.Black;
			this.Name = "SlavePresenceFull";
			this.Text = "PresenceFull";
			this.bigVideoPanel.ResumeLayout(false);
			this.otherPanel.ResumeLayout(false);
			this.ownerAwarePnl.ResumeLayout(false);
			this.panel2.ResumeLayout(false);
			this.ownerAwareDisplayPnl.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void RefreshView()
		{
			int nimbus = this.presence.Nimbus;
			this.SetVideo();
			if(nimbus < this.presence.PictureAwareness)
			{
				this.picturePictureBox.Image = null;
				this.picturePictureBox.BackColor = System.Drawing.Color.FromArgb(100,137, 153);
			}
			else if(nimbus < this.presence.VideoAwareness)
			{
				if(this.picturePictureBox.Image == null)
				{
					this.picturePictureBox.Image = this.presence.GetPicture(this.picturePictureBox.Size);
					this.picturePictureBox.BackColor = this.presence.Colour.PresenceColour;
				}
			}
			else
			{
				if(this.picturePictureBox.Image == null)
				{
					this.picturePictureBox.Image = this.presence.GetPicture(this.picturePictureBox.Size);
					this.picturePictureBox.BackColor = this.presence.Colour.PresenceColour;
				}

			}
		}

		private void presence_NimbusChanged(object sender, EventArgs e)
		{
			this.RefreshView();
		}

		private void presence_StatusChanged(object sender, EventArgs e)
		{
			this.SetStatus(this.presence.Status);
			if(this.presence.Status != "Online")
			{
				// turn everything grey
				this.statusLbl.BackColor = this.presence.Colour.AwayColour;
				this.messageLbl.BackColor = this.presence.Colour.AwayColour;
				this.bigVideoPictureBox.BackColor = this.presence.Colour.AwayColour;
				this.picturePictureBox.BackColor = this.presence.Colour.AwayColour;
				this.ownerAwareLbl.BackColor = this.presence.Colour.AwayColour;
				this.ownerAwareValueLbl.BackColor = this.presence.Colour.AwayColour;
			}
			else
			{
				// turn everything back to present colour
				this.statusLbl.BackColor = this.presence.Colour.PresenceColour;
				this.messageLbl.BackColor = this.presence.Colour.PresenceColour;
				this.bigVideoPictureBox.BackColor = this.presence.Colour.PresenceColour;
				this.picturePictureBox.BackColor = this.presence.Colour.PresenceColour;
				this.ownerAwareLbl.BackColor = this.presence.Colour.PresenceColour;
				this.ownerAwareValueLbl.BackColor = this.presence.Colour.PresenceColour;
			}
		}

		private void SetStatus(string status)
		{
			this.statusLbl.Text = status;
		}

		private void presence_MessageChanged(object sender, EventArgs e)
		{
			this.SetMessage(this.presence.Message);
		}

		private void SetMessage(string message)
		{
			this.messageLbl.Text = message;
		}

		private void presence_PictureChanged(object sender, EventArgs e)
		{
			if(this.presence.Nimbus >= this.presence.PictureAwareness)
			{
				this.picturePictureBox.Image = this.presence.GetPicture(this.picturePictureBox.Size);
			}
		}

		private void presence_BigImageChanged(object sender, EventArgs e)
		{
			this.SetVideo();
		}

		private void presence_AllowBigVideoChanged(object sender, EventArgs e)
		{
			this.SetVideo();
		}

		private void talkBtn_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			// start sending audio
			if(null == this.mic)
			{
				this.mic = new Collabrary.MicrophoneClass();
				this.mic.SetFormat(8000,8,1,8);
				this.mic.Captured += new Collabrary.MicrophoneEvents_CapturedEventHandler(this.mic_Captured);
			}
			this.mic.Recording = true;
		}

		private void talkBtn_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			// stop sending audio
			this.mic.Recording = false;

		}

		private void mic_Captured(Collabrary.IWaveform samples)
		{
			// put in the shared dictionary
			this.presence.SendAudio(samples);
		}

		private void presence_OwnerAwarenessChanged(object sender, EventArgs e)
		{
			this.ownerAwareDisplayLbl.Width = (int)((float)this.presence.OwnerAwareness/100F*this.ownerAwareDisplayPnl.Width);
			string viewString;
			if(this.presence.OwnerAwareness > this.presence.VideoAwareness)
			{
				viewString = "Video,  Message, Name, and Status.";
			}
			else if(this.presence.OwnerAwareness > this.presence.PictureAwareness)
			{
				viewString = "Picture, Message, Name,and Status.";
			}
			else if(this.presence.OwnerAwareness > this.presence.MessageAwareness)
			{
				viewString = "Message, Name, and Status.";
			}
			else if(this.presence.OwnerAwareness > this.presence.NameAwareness)
			{
				viewString = "Name and Status only.";
			}
			else
			{
				viewString = "Status only.";
			}
			this.ownerAwareValueLbl.Text = "They are looking at your " + viewString;
		}
	}
}
